#!/bin/bash
# find the line records first/last seen time in UNIX timestamp format
# $* the option for nfdump

firstts=$(nfdump -I $* | grep 'First:' | sed 's/First: //g')
lastts=$(nfdump -I $* | grep 'Last:' | sed 's/Last: //g')

if [ -z "$firstts" ] || [ -z $lastts ]
then 
	exit 1
fi

# the following commands do the same thing: convert UNIX timestamp format to customized format
#date -d @$first +%Y/%m/%d.%T

first=$(date -d '1970-01-01 '$firstts' sec GMT' +%Y/%m/%d.%T)
last=$(date -d '1970-01-01 '$lastts' sec GMT' +%Y/%m/%d.%T)
echo $first-$last
