# Get the brush color for the input data 
# by 64 rainbow color space evenly according to the value of the data
rainbowcolor <- function(x) {
  lx <- levels(factor(x))
  len <- length(lx);
  palette <- rep(64, len)
  color <- rep(1, length(x))
  if (len > 64){
    delta <- ifelse(len %% 64 > 0, len %/% 64 +1, len %/% 64)
    remainder <- len %% delta
    count <- len %/% delta
    for (i in 0:(count - 1)) {
      palette[(i * delta + 1)  : ((i + 1) * delta)] <- rep(64 + i, delta)
    }
    if (remainder > 0){
      palette[(count * delta + 1) : len] <- rep(64 + count, len - (count * delta))
    }
  }else if (len <= 64) {
    palette <- 64:(63 + len)
  }
  
  for (i in 1:len){
    color[x==lx[i]] <- palette[i]
  }

  return (color)
}
