#!/bin/bash
# convert .csv file to R workspace .ws file.
# $1 the output path.
# $2 the data name in workspace.

# output path
out=$1

if [ ! -f $out.csv ]
then
  echo "Input file [$out.csv] not found - Aborting"
    exit -1
fi

# data name in workspace
name=$2

# temporary R script name
script=$out'_preload.r'

# create temporary R script
#cat scripts/r_vismix.hdr > $script
#echo $name' <- read.table("'$out.csv'",header=T,sep=",", quote="", colClasses=classnames);rm(classnames)' >> $script
echo $name' <- read.table("'$out.csv'",header=T,sep=",", quote="");' >> $script
echo 'save.image("'$out.ws'",compress=TRUE)' >> $script

# execute R script in BATCH mode
R --no-save --slave < $script

# remove temporary R script
rm $script

# remove csv file
#rm $out.csv
