package shell;

import java.io.IOException;

import util.Task;
import util.TaskManager;

public class ShellTask extends Task {
	ShellManager sm;

	StringBuffer output;

	public ShellTask(TaskManager tm, int type, ShellManager sm, String[] args, StringBuffer out) {
		super(tm, type, args);
		this.sm = sm;
		this.output = out;
	}

	public void run() {
		try {
			if (sm.execute(args, output) == 0) {
				status = COMPLETED;
			} else {
				status = FAILED;
			}
		} catch (IOException ioe) {
			status = FAILED;
		} catch (InterruptedException ie) {
			status = CANCELLED;
		}
		tm.notifyManager(this);
	}
}
