package univis;

import java.util.Iterator;
import java.util.Vector;

import javax.swing.SwingUtilities;
import javax.swing.table.DefaultTableModel;

import shell.ShellTask;
import util.Task;
import util.TaskListener;

public class TaskTableModel extends DefaultTableModel implements TaskListener{
	TaskTableModel self;
	Vector<Task> tasks;
	Vector<Task> sTasks;
	Vector<Task> rTasks;
	
	public TaskTableModel(Vector header){
		super();
		this.columnIdentifiers = header;
		self = this;
		tasks = new Vector<Task>();
		sTasks = new Vector<Task>();
		rTasks = new Vector<Task>();
	}
	
	public Task getTask(int index){
		Task t = null;
		if (tasks == null || index < 0 || index >= tasks.size()) return null;
		t = tasks.elementAt(index);
		return t;
	}
	
	public void taskUpdated(Task t, Vector<Task> tasks) {
		if (t instanceof ShellTask || t.type == Task.PRELOAD)
			this.sTasks = (Vector<Task>) tasks.clone();
		else
			this.rTasks = (Vector<Task>) tasks.clone();
		
		this.tasks.clear();
		this.tasks.addAll(this.sTasks);
		this.tasks.addAll(rTasks);
//		Iterator i = sTasks.iterator();
//		while(i.hasNext())
//			this.tasks.add((Task)i.next());
//		i =  rTasks.iterator();
//		while(i.hasNext())
//			this.tasks.add((Task)i.next());
		
		Runnable updater = new Runnable() {
		    public void run() {
		    	self.setRowCount(0);
				for (Task task : self.tasks){
					self.addRow(task.getInfo());
				}
		    }
		};
		if (SwingUtilities.isEventDispatchThread())
			updater.run();
		else
			SwingUtilities.invokeLater(updater);
			/*try{
				SwingUtilities.invokeAndWait(updater);
			}catch(InvocationTargetException e){
				System.err.println("Exception when updating task table. Ex: " + e.getMessage());
				System.err.println(e.getStackTrace());
			}catch(InterruptedException e){
				System.err.println("Updating task table is interrupted. Ex: " + e.getMessage());
				System.err.println(e.getStackTrace());
			}*/
	}
}
