package univis;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GraphicsConfiguration;
import java.awt.GridBagConstraints;
import java.awt.GridLayout;
import java.awt.HeadlessException;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.lang.reflect.Field;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.SwingConstants;
import javax.swing.ToolTipManager;
import javax.swing.border.BevelBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeModelListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import org.rosuda.JRI.Rengine;

import r.RManager;
import r.RTask;
import r.VisTask;
import shell.ShellManager;
import shell.ShellTask;
import util.FileTreeModel;
import util.JImageLabel;
import util.Task;
import util.TaskManager;
import util.ToolTipTextField;
import util.VisDataNode;
import util.VisPlotNode;
import util.VisTreeModel;
import util.VisTreeNode;
import java.awt.GridBagLayout;

public class UniVis extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JPanel jPanel = null;

	private JPanel jPanel1 = null;

	private JPanel jPanel2 = null;

	private JPanel jPanel3 = null;

	private JPanel jPanel4 = null;

	private JPanel jPanel5 = null;

	private JLabel jLabel = null;

	private JTextField jTextField = null;

	private JPanel jPanel6 = null;

	private JLabel jLabel1 = null;

	private JTextField jTextField1 = null;

	private JPanel jPanel7 = null;

	private JLabel jLabel2 = null;

	private JTextField jTextField2 = null;

	private JPanel jPanel8 = null;

	private JPanel jPanel9 = null;

	private JButton jButton = null;

	private JButton jButton2 = null;

	private JButton jButton3 = null;

	private JTree jTree = null; // @jve:decl-index=0:visual-constraint="464,1597"

	private JPanel jPanel12 = null;

	private JPanel jPanel13 = null;

	private JPanel jPanel14 = null;

	private JPanel jPanel15 = null;

	private JTree jTree1 = null; // @jve:decl-index=0:visual-constraint="140,1568"

	private JPanel jPanel16 = null;

	private JButton jButton4 = null;

	private JList jList1 = null;

	private JPanel jPanel20 = null;

	private JButton jButton5 = null;

	private JPanel jPanel71 = null;

	private JLabel jLabel21 = null;

	private JTextField jTextField21 = null;

	public UniVis() throws HeadlessException {
		super();
		initialize();
	}

	public UniVis(GraphicsConfiguration gc) {
		super(gc);
		initialize();
	}

	public UniVis(String title) throws HeadlessException {
		super(title);
		initialize();
	}

	public UniVis(String title, GraphicsConfiguration gc) {
		super(title, gc);
		initialize();
	}

	ShellManager sm = null;

	RManager rm = null;

	TaskManager stm = null;

	TaskManager rtm = null;

	JFileChooser pathChooser = null; // @jve:decl-index=0:visual-constraint="70,1227"

	FileTreeModel fileTreeModel = null; // @jve:decl-index=0:

	VisTreeModel visTreeModel = null; // @jve:decl-index=0:

	WorkspaceListModel workspaceListModel = null; // @jve:decl-index=0:

	TaskTableModel scheduleTableModel = null; // @jve:decl-index=0:

	boolean isDumpMultiFile = true;

	boolean isDumpTimeWindow = false;

	boolean isDumpFilter = false;

	static final String[] attributes = new String[] { "ts", "tss", "te", "tes",
			"td", "pr", "prs", "sa", "sas", "sp", "da", "das", "dp", "flg",
			"flgs", "pkt", "byt", "bpp" };

	static final String[] bgColors = new String[] { "white", "lightGray",
			"darkGray", "black" };

	static final String[] fgColors = new String[] { "black", "blue", "cyan",
			"darkGray", "gray", "green", "lightGray", "magenta", "orange",
			"pink", "red", "white", "yellow" };

	static final String[] brushColors = new String[] { "0", "1", "2", "3", "4",
			"5", "6", "7", "16", "17", "18", "19", "20", "21", "22", "23" };

	private JPanel jPanel19 = null;

	private JTextField jTextField3 = null;

	private JButton jButton6 = null;

	private JButton jButton7 = null;

	private JPanel jPanel21 = null;

	private JPanel jPanel22 = null;

	private JPanel jPanel23 = null;

	private JPanel jPanel24 = null;

	private JCheckBox jCheckBox2 = null;

	private JPanel jPanel61 = null;

	private JLabel jLabel11 = null;

	private JTextField jTextField11 = null;

	private JRadioButton jRadioButton = null;

	private JRadioButton jRadioButton1 = null;

	private JPanel jPanel231 = null;

	private JCheckBox jCheckBox21 = null;

	private JPanel jPanel72 = null;

	private JLabel jLabel22 = null;

	private JTextField jTextField22 = null;

	private JPanel jPanel17 = null;

	private JPanel jPanel10 = null;

	private JPanel jPanel25 = null;

	private JPanel jPanel26 = null;

	private JLabel jLabel3 = null;

	private JTextField textfieldSelectionData = null;

	private JButton jButton9 = null;

	private JPanel jPanel27 = null;

	private JTextField textfieldSelectionFilter = null;

	private JScrollPane jScrollPane = null;

	private JLabel jLabel5 = null;

	private JPanel jPanel28 = null;

	private JPanel jPanel721 = null;

	private JLabel jLabel221 = null;

	private JTextField jTextField221 = null;

	private JScrollPane jScrollPane1 = null;

	private JScrollPane jScrollPane2 = null;

	private JTable jTable = null;

	private JPanel jPanel121 = null;

	private JPanel jPanel251 = null;

	private JPanel jPanel101 = null;

	private JPanel jPanel274 = null;

	private JLabel jLabel44 = null;

	private JPanel jPanel2711 = null;

	private JLabel jLabel411 = null;

	private JPanel jPanel2731 = null;

	private JLabel jLabel431 = null;

	private JRadioButton radiobuttonScatterPlot = null;

	private JScrollPane jScrollPane3 = null;

	private JPanel jPanel273711 = null;

	private JLabel jLabel43711 = null;

	private JRadioButton radiobuttonFilter = null;

	private JPanel jPanel11 = null;

	private JPanel jPanel111 = null;

	private JRadioButton radiobuttonIndex = null;

	private JLabel jLabel437111 = null;

	public UniVis(RManager rm, ShellManager sm, TaskManager stm, TaskManager rtm)
			throws HeadlessException {
		super();
		this.rm = rm;
		this.sm = sm;
		this.stm = stm;
		this.rtm = rtm;
		initialize();
	}

	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(new BoxLayout(getJPanel(), BoxLayout.Y_AXIS));
			jPanel.add(getJPanel1(), null);
			jPanel.add(getJPanel2(), null);
			jPanel.add(getJPanel3(), null);
			jPanel.add(getJPanel4(), null);
			Dimension size = new Dimension(
					this.getMinimumSize().width - 50,
					this.getMinimumSize().height > 1300 ? this.getMinimumSize().height - 50
							: 1250);
			jPanel.setPreferredSize(size);
		}
		return jPanel;
	}

	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(new BorderLayout());
			jPanel1.setBorder(BorderFactory.createTitledBorder(BorderFactory
					.createLineBorder(Color.lightGray, 3),
					"Dump Data ( nfdump )", TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, new Font("Dialog",
							Font.BOLD, 12), new Color(51, 51, 51)));
			jPanel1.add(getJScrollPane(), BorderLayout.CENTER);
			jPanel1.add(getJPanel19(), BorderLayout.NORTH);
			jPanel1.add(getJPanel15(), BorderLayout.SOUTH);
		}
		return jPanel1;
	}

	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
			jPanel2.setLayout(new BoxLayout(getJPanel2(), BoxLayout.Y_AXIS));
			jPanel2.setBorder(BorderFactory.createTitledBorder(BorderFactory
					.createLineBorder(Color.lightGray, 3),
					"Visualization Preparation ( R )",
					TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, new Font("Dialog",
							Font.BOLD, 12), new Color(51, 51, 51)));
			jPanel2.add(getJPanel8(), null);
			jPanel2.add(getJPanel9(), null);
		}
		return jPanel2;
	}

	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new JPanel();
			jPanel3.setLayout(new BorderLayout());
			jPanel3.setBorder(BorderFactory.createTitledBorder(BorderFactory
					.createLineBorder(Color.lightGray, 3),
					"Interactive Visualization ( iPlots )",
					TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, new Font("Dialog",
							Font.BOLD, 12), new Color(51, 51, 51)));
			jPanel3.add(getJPanel14(), BorderLayout.NORTH);
			jPanel3.add(getJPanel29(), BorderLayout.CENTER);
		}
		return jPanel3;
	}

	/**
	 * This method initializes jPanel4
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new JPanel();
			jPanel4.setLayout(new BorderLayout());
			jPanel4.setBorder(BorderFactory.createTitledBorder(BorderFactory
					.createLineBorder(Color.lightGray, 3),
					"Scheduled Task List", TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, new Font("Dialog",
							Font.BOLD, 12), new Color(51, 51, 51)));
			jPanel4.add(getJScrollPane2(), BorderLayout.CENTER);
			jPanel4.add(getJPanel31(), BorderLayout.WEST);
		}
		return jPanel4;
	}

	/**
	 * This method initializes jPanel5
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel5() {
		if (jPanel5 == null) {
			jLabel = new JLabel();
			jLabel.setText("-M ");
			jPanel5 = new JPanel();
			jPanel5.setLayout(new BorderLayout());
			jPanel5.add(jLabel, BorderLayout.WEST);
			jPanel5.add(getJTextField(), BorderLayout.CENTER);
		}
		return jPanel5;
	}

	/**
	 * This method initializes jTextField
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new ToolTipTextField();
			jTextField.setText("/any/path/to/dir1:dir2");
		}
		return jTextField;
	}

	/**
	 * This method initializes jPanel6
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel6() {
		if (jPanel6 == null) {
			jLabel1 = new JLabel();
			jLabel1.setText("-r   ");
			jPanel6 = new JPanel();
			jPanel6.setLayout(new BorderLayout());
			jPanel6.add(jLabel1, BorderLayout.WEST);
			jPanel6.add(getJTextField1(), BorderLayout.CENTER);
		}
		return jPanel6;
	}

	/**
	 * This method initializes jTextField1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new ToolTipTextField();
			jTextField1.setText("/any/path/to/file");
			jTextField1.setEnabled(false);
		}
		return jTextField1;
	}

	/**
	 * This method initializes jPanel7
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel7() {
		if (jPanel7 == null) {
			jLabel2 = new JLabel();
			jLabel2.setText("-f   ");
			jPanel7 = new JPanel();
			jPanel7.setLayout(new BorderLayout());
			jPanel7.add(jLabel2, BorderLayout.WEST);
			jPanel7.add(getJTextField2(), BorderLayout.CENTER);
		}
		return jPanel7;
	}

	/**
	 * This method initializes jTextField2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new ToolTipTextField();
			jTextField2.setEnabled(false);
		}
		return jTextField2;
	}

	/**
	 * This method initializes jPanel8
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel8() {
		if (jPanel8 == null) {
			jPanel8 = new JPanel();
			jPanel8.setLayout(new BorderLayout());
			jPanel8.add(getJPanel20(), BorderLayout.CENTER);
			jPanel8.add(getJPanel17(), BorderLayout.EAST);
		}
		return jPanel8;
	}

	/**
	 * This method initializes jPanel9
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel9() {
		if (jPanel9 == null) {
			jPanel9 = new JPanel();
			jPanel9.setLayout(new BorderLayout());
			jPanel9.setBorder(BorderFactory.createTitledBorder(null,
					"Data Processing", TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, new Font("Dialog",
							Font.BOLD, 12), new Color(51, 51, 51)));
		}
		return jPanel9;
	}
	
	Hashtable<String, String> workspace;  //  @jve:decl-index=0:

	/**
	 * This method initializes jButton
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText("Load Data");
			jButton.setName("jButton");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String path = jTextField21.getText();
					File dir = new File(path
							.substring(0, path.lastIndexOf('/')));
					if (!dir.isDirectory())
						return;
					pathChooser.setDialogTitle("Choose the data file to load");
					pathChooser
							.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
					pathChooser.setCurrentDirectory(dir);
					FileFilter ff = pathChooser.getFileFilter();
					pathChooser.setFileFilter(new FileNameExtensionFilter(
							"R Workspace files (gzip)", "ws"));
					int returnVal = pathChooser.showOpenDialog(jButton);

					if (returnVal == JFileChooser.APPROVE_OPTION) {
						File f = pathChooser.getSelectedFile();
						RTask rt = new RTask(rtm, Task.LOAD, rm, rm
								.getLoadWorkspaceCmd(f));
						rtm.addTask(rt);
						String dataName = f.getName().substring(0, f.getName().length() - 3);
						String filter;
						if ((filter = getFilter(new File(f.getParent() + "/" + dataName+".filter")))!=null)
							workspace.put(dataName, filter);
						// updateWorkspaceList();
					}

					pathChooser.setFileFilter(ff);
				}
				
				private String getFilter(File f){
					System.out.println(f.getPath());
//				  ...checks on aFile are elided
					if (!f.canRead()) return null;
				    StringBuffer contents = new StringBuffer();
				    
				    try {
				      //use buffering, reading one line at a time
				      //FileReader always assumes default encoding is OK!
				      BufferedReader input =  new BufferedReader(new FileReader(f));
				      try {
				        String line = null; //not declared within while loop
				        /*
				        * readLine is a bit quirky :
				        * it returns the content of a line MINUS the newline.
				        * it returns null only for the END of the stream.
				        * it returns an empty String if two newlines appear in a row.
				        */
				        while (( line = input.readLine()) != null){
				          contents.append(line);
				          contents.append(System.getProperty("line.separator"));
				        }
				      }
				      finally {
				        input.close();
				      }
				    }
				    catch (IOException ex){
				      ex.printStackTrace();
				    }
				    
				    return contents.toString();
				}
			});
		}
		return jButton;
	}

	private void loadData(File f) {

	}

	private void updateWorkspace(String[] dataList) {

	}

	/**
	 * This method initializes jButton2
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setText("Unload Data");
			jButton2.setName("jButton2");
			jButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("unload data");
					// Event stub
					// actionPerformed()
					String selected = (String) jList1.getSelectedValue();
					rm.unload(selected);
					workspaceListModel.update(rm.getDataList());
					workspace.remove(selected);
				}
			});
		}
		return jButton2;
	}

	/**
	 * This method initializes jButton3
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton3() {
		if (jButton3 == null) {
			jButton3 = new JButton();
			jButton3.setText("Save Workspace");
			jButton3.setName("jButton3");
			jButton3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("save workspace");
					// Auto-generated
					// Event stub
					// actionPerformed()
					pathChooser.setDialogTitle("save current workspace as");
					pathChooser
							.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
					pathChooser.setCurrentDirectory(new File(jTextField3
							.getText()
							+ "/workspace"));
					int returnVal = pathChooser.showSaveDialog(jButton);

					if (returnVal == JFileChooser.APPROVE_OPTION) {
						File f = pathChooser.getSelectedFile();
						System.out.println("Start saving " + f.getPath());
						rm.saveWorkspace(f);
						System.out.println("Complete saving " + f.getPath());
					}
				}
			});
		}
		return jButton3;
	}

	/**
	 * This method initializes jTree
	 * 
	 * @return javax.swing.JTree
	 */
	private JTree getJTree() {
		if (jTree == null) {
			jTree = new JTree(visTreeModel) {
				public boolean isCellEditable(int row, int column) {
					return false;
				}

				// Implement table cell tool tips.
				public String getToolTipText(MouseEvent e) {
					String tip = null;
					Point p = e.getPoint();
					TreePath treePath = this.getPathForLocation(p.x, p.y);
					if (treePath == null)
						return tip;
					VisTreeNode node = ((VisTreeNode) treePath
							.getLastPathComponent());
					if (node == null)
						return tip;

					tip = node.description.replace("\n", "<br>");
					tip = "<html>"
							+ (tip.contains("Original Index:") ? tip.substring(
									0, tip.lastIndexOf("Original Index:"))
									: tip) + "</html>";
					return tip;
				}
			};
			ToolTipManager.sharedInstance().registerComponent(jTree);
			// jTree.setRootVisible(false);
			// jTree.setPreferredSize(new Dimension(this.getMinimumSize().width
			// - 250, 50));
			visTreeModel.addTreeModelListener(new TreeModelListener() {
				public void treeNodesChanged(TreeModelEvent e) {
				}

				public void treeNodesInserted(TreeModelEvent e) {
					System.err
							.println("new child added: "
									+ ((VisTreeNode) (e.getChildren()[e
											.getChildren().length - 1])).name);
					textfieldSelectionData.setText(((VisTreeNode) e
							.getTreePath().getLastPathComponent()).toString());
				}

				public void treeNodesRemoved(TreeModelEvent e) {
					System.err
							.println("child removed: "
									+ ((VisTreeNode) (e.getChildren()[e
											.getChildren().length - 1])).name);
				}

				public void treeStructureChanged(TreeModelEvent e) {
				}
			});
//			jTree.addTreeSelectionListener(new TreeSelectionListener() {
//				public void valueChanged(TreeSelectionEvent event) {
//					if (jTree.isSelectionEmpty()) {
						//textfieldSelectionData.setText("");
//						return;
//					}

//					String selected = jTree.getSelectionPath()
//							.getLastPathComponent().toString();
//					textfieldSelectionData.setText(selected);
					// VisTreeNode node = visTreeModel.getNode(selected);
					// if (node instanceof VisPlotNode){
					// rm.togglePlot((VisPlotNode)node);
					// }else{
					// rm.togglePlots((VisDataNode)node);
					// }
//				}
//			});
			jTree.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent e) {
					Point p = e.getPoint();
					TreePath treePath = jTree.getPathForLocation(p.x, p.y);
					if (treePath == null)
						return;
					VisTreeNode node = ((VisTreeNode) treePath
							.getLastPathComponent());
					if (node == null)
						return;
					if (e.getButton() == e.BUTTON3) {
						if (node instanceof VisPlotNode)
							return;
						jTextField4.setText(node.name);
					} else if (e.getButton() == e.BUTTON2) {
						if (node instanceof VisDataNode)
							setBrushColor(((VisDataNode) node).color);
					} else if (e.getButton() == e.BUTTON1){
						if (jTree.isSelectionEmpty())
							return;

						String selected = jTree.getSelectionPath()
								.getLastPathComponent().toString();
						textfieldSelectionData.setText(selected);
					}
				}
			});
		}
		return jTree;
	}

	/**
	 * This method initializes jPanel12
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel12() {
		if (jPanel12 == null) {
			jPanel12 = new JPanel();
			jPanel12.setLayout(new BorderLayout());
			jPanel12.setBorder(BorderFactory.createTitledBorder(null,
					"Selection", TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, new Font("Dialog",
							Font.BOLD, 12), new Color(51, 51, 51)));
			jPanel12.add(getJPanel25(), BorderLayout.WEST);
			jPanel12.add(getJPanel10(), BorderLayout.CENTER);
			jPanel12.add(getJPanel26(), BorderLayout.EAST);
		}
		return jPanel12;
	}

	/**
	 * This method initializes jPanel13
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel13() {
		if (jPanel13 == null) {
			jPanel13 = new JPanel();
			jPanel13.setLayout(new BorderLayout());
			jPanel13.setBorder(BorderFactory.createTitledBorder(null,
					"Parallel Coordinate Plot",
					TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, null, null));
			jPanel13.add(getJPanel2511(), BorderLayout.WEST);
			jPanel13.add(getJPanel35(), BorderLayout.CENTER);
		}
		return jPanel13;
	}

	/**
	 * This method initializes jPanel14
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel14() {
		if (jPanel14 == null) {
			jPanel14 = new JPanel();
			jPanel14.setLayout(new BoxLayout(getJPanel14(), BoxLayout.Y_AXIS));
			jPanel14.add(getJPanel12(), null);
			jPanel14.add(getJPanel122(), null);
			jPanel14.add(getJPanel121(), null);
			jPanel14.add(getJPanel13(), null);
			jPanel14.add(getJPanel39(), null);
			jPanel14.add(getJPanel132(), null);
		}
		return jPanel14;
	}

	/**
	 * This method initializes jPanel15
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel15() {
		if (jPanel15 == null) {
			jPanel15 = new JPanel();
			jPanel15.setLayout(new BoxLayout(getJPanel15(), BoxLayout.Y_AXIS));
			jPanel15.add(getJPanel21(), null);
			jPanel15.add(getJPanel22(), null);
			jPanel15.add(getJPanel231(), null);
			jPanel15.add(getJPanel23(), null);
			jPanel15.add(getJPanel24(), null);
		}
		return jPanel15;
	}

	private String getHumanReadableNumber(String in) {
		String out = "";

		int i = in.length();

		if (i >= 10)
			out = in.substring(0, i - 9) + "G";
		else if (i >= 7)
			out = in.substring(0, i - 6) + "M";
		else if (i >= 4)
			out = in.substring(0, i - 3) + "K";
		else
			out = in.toString();

		return out;
	}

	/**
	 * This method initializes jTree1
	 * 
	 * @return javax.swing.JTree
	 */
	private JTree getJTree1() {
		if (jTree1 == null) {
			jTree1 = new JTree(fileTreeModel) {
				public boolean isCellEditable(int row, int column) {
					return false;
				}

				// Implement table cell tool tips.
				public String getToolTipText(MouseEvent e) {
					String tip = null;
					Point p = e.getPoint();
					TreePath treePath = this.getPathForLocation(p.x, p.y);
					if (treePath == null)
						return tip;
					DefaultMutableTreeNode node = ((DefaultMutableTreeNode) treePath
							.getLastPathComponent());
					if (node == null)
						return tip;
					String path = node.toString();

					String[] cmds = new String[] { "scripts/getflownumber.sh",
							path };

					StringBuffer output = new StringBuffer();

					try {
						if (sm.execute(cmds, output) == 0
								&& output.length() > 0)
							tip = "Flow Number: "
									+ getHumanReadableNumber(output.toString())
									+ "(" + output.toString() + ")";
					} catch (Exception ex) {
						System.err
								.println("Failed to get flow number from nfdump binary file. EX:\n"
										+ ex.getStackTrace());
					}

					return tip;
				}
			};
			ToolTipManager.sharedInstance().registerComponent(jTree1);
			
			jTree1.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent e) {
//			jTree1.addTreeSelectionListener(new TreeSelectionListener() {
//				public void valueChanged(TreeSelectionEvent event) {
					if (jTree1.isSelectionEmpty())
						return;
					if (isDumpMultiFile) {
						if (jTree1.getSelectionCount() == 1)
							return;
						int[] selected = jTree1.getSelectionRows();
						int firstRow = jTree1.getMinSelectionRow();
						int lastRow = jTree1.getMaxSelectionRow();
						int[] range = new int[] { firstRow, lastRow };
						jTree1.setSelectionRows(range);
						TreePath first = jTree1.getPathForRow(firstRow);
						TreePath last = jTree1.getPathForRow(lastRow);
						String[] firstPath = first.getParentPath().getLastPathComponent().toString().split("/");
						String[] lastPath = last.getParentPath().getLastPathComponent().toString().split("/");
						
						File firstFile = new File(first.getLastPathComponent().toString());
						File lastFile = new File(last.getLastPathComponent().toString());
						if (firstFile.isFile() && lastFile.isFile()) {
							int lastMatch = getIndexOfLastMatchPath(firstPath, lastPath);
							if (lastMatch != -1){
								String str = getPath(0, lastMatch, firstPath);
								jTextField.setText(str);
								str =  getPath(lastMatch + 1, firstPath.length, firstPath) + firstFile.getName()+ ":" 
									+ getPath(lastMatch + 1, lastPath.length, lastPath) + lastFile.getName();
								jTextField11.setText(str);
							}
						}
					} else {
						TreePath selected = jTree1.getSelectionPath();
						jTree1.setSelectionPath(selected);
						File file = new File(selected.getLastPathComponent()
								.toString());
						if (file.isFile()) {
							String str = file.getPath();
							jTextField1.setText(str);
						}
					}
					// DefaultMutableTreeNode n = (DefaultMutableTreeNode)
					// jTree1
					// .getLastSelectedPathComponent();
					// File f = (File) n.getUserObject();
					// jTextField3.setText(n.toString());
				}
				
				private int getIndexOfLastMatchPath(String[] s1, String[] s2){
					int last = -1;
					for (int i=0; i < (s1.length < s2.length ? s1.length : s2.length); i++){
						if (s1[i].equals(s2[i]))
							last=i;
						else
							break;
					}
					return last;
				}
				
				private String getPath(int from, int to, String[] s){
					String str = "";
					if (from > to || to > s.length) return null;
					for (int i = from; i < s.length; i++){
						str += s[i] + "/";
					}
					return str;
				}
			});
		}
		return jTree1;
	}

	/**
	 * This method initializes jPanel16
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel16() {
		if (jPanel16 == null) {
			jPanel16 = new JPanel();
			jPanel16.setLayout(new BorderLayout());
			jPanel16.add(getJTextField21(), BorderLayout.CENTER);
		}
		return jPanel16;
	}

	/**
	 * This method initializes jButton4
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton4() {
		if (jButton4 == null) {
			jButton4 = new JButton();
			jButton4.setText("Dump");
			jButton4.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// System.out.println("Dump started.");

					String indir = jTextField.getText();
					String infile = jTextField11.getText();
					String inpath = jTextField1.getText();
					String timefirst = jTextField22.getText();
					String timelast = jTextField221.getText();
					String timewindow = timefirst + "-" + timelast;
					String filter = jTextField2.getText();
					String outpath = jTextField21.getText();
					if (new File(outpath).isDirectory())
						return;

					if (isDumpFilter && !new File(filter).isFile()) {
						File f = new File(outpath + ".filter");
						try {
							BufferedWriter out = new BufferedWriter(
									new FileWriter(f));
							out.write(filter);
							out.close();
						} catch (IOException ioe) {
							System.err
									.println("Failed writing filter expression to file : "
											+ f.getPath() + ". Ex: " + ioe);
							ioe.printStackTrace();
						}
						filter = f.getPath();
					}

					String[] dump = sm.getDumpCmd(isDumpMultiFile ? indir : "",
							isDumpMultiFile ? infile : "",
							!isDumpMultiFile ? inpath : "",
							isDumpTimeWindow ? timewindow : "",
							isDumpFilter ? filter : "", outpath + ".csv");

					// String[] test = new String[] { "scripts/dump.sh",
					// outpath + ".csv", "", "", "-r", inpath, "", "" };
					ShellTask st = new ShellTask(stm, Task.DUMP, sm, dump, null);
					stm.addTask(st);
				}
			});
		}
		return jButton4;
	}

	/**
	 * This method initializes jList1
	 * 
	 * @return javax.swing.JList
	 */
	private JList getJList1() {
		if (jList1 == null) {
			workspaceListModel = new WorkspaceListModel();

			rtm.addTaskListener(workspaceListModel);
			jList1 = new JList(workspaceListModel) {
				public boolean isCellEditable(int row, int column) {
					return false;
				}

				// Implement table cell tool tips.
				public String getToolTipText(MouseEvent e) {
					String tip = null;
					Point p = e.getPoint();
					int index = this.locationToIndex(p);
					String temp = null;

					if (index != -1) {
						tip = rm.getFlowNumber((String) workspaceListModel
								.get(index));
						tip = "Flow Number: " + getHumanReadableNumber(tip)
								+ "(" + tip + ")\n";
						if ((temp = workspace.get((String) workspaceListModel
								.get(index))) != null){
							tip += "Dump Filter: " + temp;
							tip = "<html>" + tip.replace("\n", "<br>") + "</html>";
						}
					}

					return tip;
				}
			};
			jList1.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent e) {
					String data = (String) jList1.getSelectedValue();
					textfieldSelectionData.setText(data);
				}
			});
		}
		return jList1;
	}

	/**
	 * This method initializes jPanel20
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel20() {
		if (jPanel20 == null) {
			jPanel20 = new JPanel();
			jPanel20.setLayout(new BorderLayout());
			jPanel20.add(getJScrollPane1(), BorderLayout.CENTER);
		}
		return jPanel20;
	}

	/**
	 * This method initializes jButton5
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton5() {
		if (jButton5 == null) {
			jButton5 = new JButton();
			jButton5.setText("Clear Workspace");
			jButton5.setName("jButton5");
			jButton5.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("clear workspace"); // TODO
					// Auto-generated
					// Event stub
					// actionPerformed()
					rm.clearWorkspace();
					workspaceListModel.update(rm.getDataList());
					workspace.clear();
				}
			});
		}
		return jButton5;
	}

	/**
	 * This method initializes jPanel71
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel71() {
		if (jPanel71 == null) {
			jLabel21 = new JLabel();
			jLabel21.setText("     >    ");
			jPanel71 = new JPanel();
			jPanel71.setLayout(new BorderLayout());
			jPanel71.add(jLabel21, java.awt.BorderLayout.WEST);
			jPanel71.add(getJPanel16(), BorderLayout.CENTER);
			jPanel71.add(getJPanel32(), BorderLayout.EAST);
		}
		return jPanel71;
	}

	/**
	 * This method initializes jTextField21
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField21() {
		if (jTextField21 == null) {
			jTextField21 = new ToolTipTextField();
		}
		jTextField21.setText(getJTextField3().getText() + "/workspace/");
		jTextField21.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				String dir = jTextField21.getText();
				if ((dir.charAt(dir.length() - 1) == '/')
						&& !(new File(dir).isDirectory())) {
					// Create one directory
					boolean success = (new File(dir)).mkdir();
					if (success) {
						System.out.println("Directory: " + dir + " created");
					} else {
						System.out
								.println("Failed to Create Directory: " + dir);
						return;
					}
				}
			}
		});

		return jTextField21;
	}

	/**
	 * This method initializes jPanel19
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel19() {
		if (jPanel19 == null) {
			jPanel19 = new JPanel();
			jPanel19.setLayout(new BorderLayout());
			jPanel19.add(getJTextField3(), BorderLayout.CENTER);
			jPanel19.add(getJButton6(), BorderLayout.WEST);
			jPanel19.add(getJButton7(), BorderLayout.EAST);
		}
		return jPanel19;
	}

	/**
	 * This method initializes jTextField3
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField3() {
		if (jTextField3 == null) {
			jTextField3 = new JTextField();
			jTextField3.setText("/home/jin/data");
			jTextField3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("enter new root path"); // TODO
					// Auto-generated
					// Event stub
					// actionPerformed()
					updateRootPath(new File(jTextField3.getText()));
				}
			});
		}
		return jTextField3;
	}

	/**
	 * This method initializes jButton6
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton6() {
		if (jButton6 == null) {
			jButton6 = new JButton();
			jButton6.setText("Choose Root Path");
			jButton6.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("choose root path"); // TODO
					// Auto-generated
					// Event stub
					// actionPerformed()
					pathChooser
							.setDialogTitle("Choose the directory as the root path");
					pathChooser
							.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
					pathChooser.setCurrentDirectory(new File(jTextField3
							.getText()));
					int returnVal = pathChooser.showOpenDialog(jButton6);

					if (returnVal == JFileChooser.APPROVE_OPTION) {
						File f = pathChooser.getSelectedFile();
						jTextField3.setText(f.getPath());
						updateRootPath(f);
					}
				}
			});
		}
		return jButton6;
	}

	private void updateRootPath(File f) {
		if (!f.isDirectory())
			return;
		fileTreeModel.setRoot(f);
		fileTreeModel.reload();
		getJTextField21();
	}

	/**
	 * This method initializes jButton7
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton7() {
		if (jButton7 == null) {
			jButton7 = new JButton();
			jButton7.setText("Refresh");
			jButton7.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.out.println("refresh file tree"); // TODO
					// Auto-generated
					// Event stub
					// actionPerformed()
					// jTextField21.setText(getJTextField3().getText() +
					// "/csv/");
					updateRootPath(new File(jTextField3.getText()));
				}
			});
		}
		return jButton7;
	}

	/**
	 * This method initializes jPanel21
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel21() {
		if (jPanel21 == null) {
			jPanel21 = new JPanel();
			jPanel21.setLayout(new BoxLayout(getJPanel21(), BoxLayout.X_AXIS));
			jPanel21.add(getJRadioButton(), null);
			jPanel21.add(getJPanel5(), null);
			jPanel21.add(getJPanel61(), null);
		}
		return jPanel21;
	}

	/**
	 * This method initializes jPanel22
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel22() {
		if (jPanel22 == null) {
			jPanel22 = new JPanel();
			jPanel22.setLayout(new BorderLayout());
			jPanel22.add(getJRadioButton1(), BorderLayout.WEST);
			jPanel22.add(getJPanel6(), BorderLayout.CENTER);
		}
		return jPanel22;
	}

	/**
	 * This method initializes jPanel23
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel23() {
		if (jPanel23 == null) {
			jPanel23 = new JPanel();
			jPanel23.setLayout(new BorderLayout());
			jPanel23.add(getJCheckBox2(), BorderLayout.WEST);
			jPanel23.add(getJPanel7(), BorderLayout.CENTER);
		}
		return jPanel23;
	}

	/**
	 * This method initializes jPanel24
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel24() {
		if (jPanel24 == null) {
			jPanel24 = new JPanel();
			jPanel24.setLayout(new BorderLayout());
			jPanel24.add(getJPanel71(), BorderLayout.CENTER);
		}
		return jPanel24;
	}

	/**
	 * This method initializes jCheckBox2
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox2() {
		if (jCheckBox2 == null) {
			jCheckBox2 = new JCheckBox();
			jCheckBox2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (jCheckBox2.isSelected())
						isDumpFilter = true;
					else
						isDumpFilter = false;
					jTextField2.setEnabled(isDumpFilter);
				}
			});
		}
		return jCheckBox2;
	}

	/**
	 * This method initializes jPanel61
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel61() {
		if (jPanel61 == null) {
			jLabel11 = new JLabel();
			jLabel11.setText("-R ");
			jPanel61 = new JPanel();
			jPanel61.setLayout(new BorderLayout());
			jPanel61.add(jLabel11, java.awt.BorderLayout.WEST);
			jPanel61.add(getJTextField11(), java.awt.BorderLayout.CENTER);
		}
		return jPanel61;
	}

	/**
	 * This method initializes jTextField11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField11() {
		if (jTextField11 == null) {
			jTextField11 = new ToolTipTextField();
			jTextField11.setText("file1:file2 ");
		}
		return jTextField11;
	}

	private void enableDumpMultiFile() {
		jRadioButton1.setSelected(!isDumpMultiFile);
		jTextField1.setEnabled(!isDumpMultiFile);

		jRadioButton.setSelected(isDumpMultiFile);
		jTextField.setEnabled(isDumpMultiFile);
		jTextField11.setEnabled(isDumpMultiFile);
	}

	/**
	 * This method initializes jRadioButton
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			jRadioButton = new JRadioButton();
			jRadioButton.setSelected(true);
			jRadioButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (jRadioButton.isSelected() == isDumpMultiFile)
						return;
					isDumpMultiFile = !isDumpMultiFile;
					enableDumpMultiFile();
				}
			});
		}
		return jRadioButton;
	}

	/**
	 * This method initializes jRadioButton1
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			jRadioButton1 = new JRadioButton();
			jRadioButton1
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (jRadioButton1.isSelected() == !isDumpMultiFile)
								return;
							isDumpMultiFile = !isDumpMultiFile;
							enableDumpMultiFile();
						}
					});
		}
		return jRadioButton1;
	}

	/**
	 * This method initializes jPanel231
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel231() {
		if (jPanel231 == null) {
			jPanel231 = new JPanel();
			jPanel231.setLayout(new BorderLayout());
			jPanel231.add(getJCheckBox21(), BorderLayout.WEST);
			jPanel231.add(getJPanel28(), BorderLayout.CENTER);
		}
		return jPanel231;
	}

	/**
	 * This method initializes jCheckBox21
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox21() {
		if (jCheckBox21 == null) {
			jCheckBox21 = new JCheckBox();
			jCheckBox21.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (jCheckBox21.isSelected())
						isDumpTimeWindow = true;
					else
						isDumpTimeWindow = false;
					jTextField22.setEnabled(isDumpTimeWindow);
					jTextField221.setEnabled(isDumpTimeWindow);

					if (!jCheckBox21.isSelected())
						return;
					System.out.println("Try to get timewindow."); // TODO
					// Auto-generated
					// Event stub
					// actionPerformed()
					String indir = jTextField.getText();
					String infile = jTextField11.getText();
					String inpath = jTextField1.getText();

					String[] getTimewindow = sm.getTimewindowCmd(
							isDumpMultiFile ? indir : "",
							isDumpMultiFile ? infile : "",
							!isDumpMultiFile ? inpath : "");

					String[] test = new String[] { "scripts/gettimewindow.sh",
							"", "", "-r", inpath };
					StringBuffer sb = new StringBuffer();
					ShellTask st = new ShellTask(stm, Task.GETTIMEWINDOW, sm,
							getTimewindow, sb);
					st.run();
					if (st.status == Task.COMPLETED) {
						String timefirst = sb.substring(0, 19);
						String timelast = sb.substring(20, 39);
						jTextField22.setText(timefirst);
						jTextField221.setText(timelast);
					}
				}
			});
		}
		return jCheckBox21;
	}

	/**
	 * This method initializes jPanel72
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel72() {
		if (jPanel72 == null) {
			jLabel22 = new JLabel();
			jLabel22.setText("-t   ");
			jPanel72 = new JPanel();
			jPanel72.setLayout(new BorderLayout());
			jPanel72.add(jLabel22, java.awt.BorderLayout.WEST);
			jPanel72.add(getJTextField22(), java.awt.BorderLayout.CENTER);
		}
		return jPanel72;
	}

	/**
	 * This method initializes jTextField22
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField22() {
		if (jTextField22 == null) {
			jTextField22 = new ToolTipTextField();
			jTextField22.setEnabled(false);
			jTextField22.setText(" yyyy/MM/dd.hh:mm:ss");
		}
		return jTextField22;
	}

	/**
	 * This method initializes jPanel17
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel17() {
		if (jPanel17 == null) {
			GridLayout gridLayout = new GridLayout(0, 1);
			jPanel17 = new JPanel();
			jPanel17.setLayout(gridLayout);
			jPanel17.add(getJButton(), null);
			jPanel17.add(getJButton2(), null);
			jPanel17.add(getJButton5(), null);
			jPanel17.add(getJButton3(), null);
		}
		return jPanel17;
	}

	/**
	 * This method initializes jPanel10
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel10() {
		if (jPanel10 == null) {
			jPanel10 = new JPanel();
			jPanel10.setLayout(new BorderLayout());
			jPanel10.add(getJPanel273711(), BorderLayout.WEST);
			jPanel10.add(getJPanel27(), BorderLayout.CENTER);
		}
		return jPanel10;
	}

	/**
	 * This method initializes jPanel25
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel25() {
		if (jPanel25 == null) {
			jLabel3 = new JLabel();
			jLabel3.setText("          data          ");
			jPanel25 = new JPanel();
			jPanel25.setLayout(new BorderLayout());
			jPanel25.add(jLabel3, BorderLayout.CENTER);
			jPanel25.add(getJTextField4(), BorderLayout.SOUTH);
		}
		return jPanel25;
	}

	/**
	 * This method initializes jPanel26
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel26() {
		if (jPanel26 == null) {
			jPanel26 = new JPanel();
			jPanel26.setLayout(new BoxLayout(getJPanel26(), BoxLayout.Y_AXIS));
			jPanel26.add(getJPanel341(), null);
			jPanel26.add(getJPanel34(), null);
		}
		return jPanel26;
	}

	/**
	 * This method initializes jTextField4
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField4() {
		if (textfieldSelectionData == null) {
			textfieldSelectionData = new ToolTipTextField();
		}
		return textfieldSelectionData;
	}

	boolean isFilterSelection = true;

	protected String getSelectionFilter() {
		String filter = "";
		StringBuffer sb = new StringBuffer();
		int indexStringLengthLimit = 100;

		if (isFilterSelection) {
			sb.append(textfieldSelectionFilter.getText());
		} else {
			sb.append(rm.getSelectedIndex(textfieldSelectionData.getText()));
			textfieldSelectionIndex
					.setText(filter
							.substring(
									0,
									filter.length() > indexStringLengthLimit ? indexStringLengthLimit
											: filter.length())
							+ "...");
		}

		if (sb.length() > 0) {
			filter = sb.toString();
		}

		return filter;
	}

	/**
	 * This method initializes jButton9
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton9() {
		if (jButton9 == null) {
			jButton9 = new JButton();
			jButton9.setText("Visuslize");
			jButton9.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					VisPlotNode plot = null;
					VisDataNode parent = null;
					VisDataNode data = null;

					String dataName = textfieldSelectionData.getText();
					if (dataName.equals(""))
						return;

					if ((parent = visTreeModel.getDataNode(dataName)) == null) {
						if (workspaceListModel.indexOf(dataName) == -1)
							return;
						else {
							// create bogus data node from VisRoot
							data = new VisDataNode(dataName, "Bogus data node",
									!isSaveOnly);
							data.datafilter = "";
							data.originalIndex = "ALL";
							addObject(visTreeModel.getRoot(), data, true);
							parent = data;
						}
					}
					// System.err.println("parent: " + parent.name + " of level:
					// " + parent.getLevel());

					// create normal data node from other data node
					String filter = getSelectionFilter();
					// System.err.println("filter: " + filter);
					Vector result = rm.getIndex(filter, parent,
							isFilterSelection);
					String index = (String) result.elementAt(0);
					parent = (VisDataNode) result.elementAt(1);
					// System.err.println("parent later: " + parent.name + " of
					// level: " + parent.getLevel());
					// System.err.println("index: " + index);
					if ((data = visTreeModel.getSameDataNode(index, parent)) == null) {
						// int ctr = (parent.getChildCount() -
						// visTreeModel.getLeafChildCount(parent));
						if (parent.getLevel() == 1)
							data = new VisDataNode(parent.name + "_"
									+ parent.childDataNodeCounter++,
									!isSaveOnly);
						else
							data = new VisDataNode(parent.name + "."
									+ parent.childDataNodeCounter++,
									!isSaveOnly);
						data.datafilter = filter;
						data.originalIndex = index;
						addObject(parent, data, true);
						if (!rm.createISet(parent, data))
							System.err.println("Create iSet error.");

						data.flowNumber = rm.getFlowNumber(data);
						data.setDescription();
					}
					parent = data;

					// create plot node from normal data node
					// plot = new VisPlotNode(parent.name + "_"
					// + visTreeModel.getLeafChildCount(parent));
					String[] attributes = null;
					String bg = "";
					String fg = "";
					if (plotType == -1) {
						VisDataNode template;
						if ((template = visTreeModel
								.getDataNode(getJTextField42().getText())) == null) {
							System.err.println("Template node does not exist.");
						} else {
							int childrenNumber = template.getChildCount();
							for (int i = 0; i < childrenNumber; i++) {
								VisTreeNode node = (VisTreeNode) template
										.getChildAt(i);
								if (node instanceof VisPlotNode) {
									plot = ((VisPlotNode) node);
									plot = new VisPlotNode(
											parent.name
													+ "_"
													+ parent.childPlotNodeCounter++,
											visTreeModel
													.getLeafChildCount(parent) + 1,
											!isSaveOnly, plot.type,
											plot.attributes, plot.background,
											plot.foreground);
									plot(parent, plot);
								}
							}
						}
					} else if (plotType == VisPlotNode.ScatterPlot) {
						attributes = new String[] {
								comboboxScatterPlotX.getSelectedItem()
										.toString(),
								comboboxScatterPlotY.getSelectedItem()
										.toString() };
						bg = (String) (comboboxScatterPlotBgColor
								.getSelectedItem());
						fg = (String) (comboboxScatterPlotFgColor
								.getSelectedItem());

						plot = new VisPlotNode(parent.name + "_"
								+ parent.childPlotNodeCounter++, visTreeModel
								.getLeafChildCount(parent) + 1, !isSaveOnly,
								plotType, attributes, bg, fg);
						plot(parent, plot);
					} else if (plotType == VisPlotNode.ParallelCoordinatePlot) {
						attributes = jTextField5.getText().split(",");
						fg = (String) (comboboxParallelCoordinatePlotFgColor
								.getSelectedItem());

						plot = new VisPlotNode(parent.name + "_"
								+ parent.childPlotNodeCounter++, visTreeModel
								.getLeafChildCount(parent) + 1, !isSaveOnly,
								plotType, attributes, bg, fg);
						plot(parent, plot);
					} else if (plotType == VisPlotNode.Histogram) {
						attributes = new String[] { comboboxScatterPlotX1
								.getSelectedItem().toString() };

						fg = (String) (comboboxHistogramFgColor
								.getSelectedItem());

						plot = new VisPlotNode(parent.name + "_"
								+ parent.childPlotNodeCounter++, visTreeModel
								.getLeafChildCount(parent) + 1, !isSaveOnly,
								plotType, attributes, bg, fg);
						plot(parent, plot);
					} else if (plotType == VisPlotNode.BarChart) {
						attributes = new String[] { comboboxScatterPlotX11
								.getSelectedItem().toString() };
						fg = (String) (comboboxBarchartFgColor
								.getSelectedItem());

						plot = new VisPlotNode(parent.name + "_"
								+ parent.childPlotNodeCounter++, visTreeModel
								.getLeafChildCount(parent) + 1, !isSaveOnly,
								plotType, attributes, bg, fg);
						plot(parent, plot);
					} else if (plotType == VisPlotNode.MosaicPlot) {
						attributes = jTextField511.getText().split(",");
						fg = (String) (comboboxParallelCoordinatePlotFgColor1
								.getSelectedItem());

						plot = new VisPlotNode(parent.name + "_"
								+ parent.childPlotNodeCounter++, visTreeModel
								.getLeafChildCount(parent) + 1, !isSaveOnly,
								plotType, attributes, bg, fg);
						plot(parent, plot);
					}
				}

				private void plot(VisDataNode parent, VisPlotNode plot) {
					addObject(parent, plot, true);

					String[] cmds = rm.getVisCmd(plot);
					VisTask vt = new VisTask(rtm, Task.VISUALIZE, rm, cmds);
					rtm.addTask(vt);
					plot.setDescription();
					visTreeModel.reload(plot);
				}

				/*
				 * private VisTreeNode getSelectedNode(){ VisTreeNode
				 * parentNode=null; TreePath parentPath =
				 * jTree.getSelectionPath(); if (parentPath == null) { //There
				 * is no selection. Default to the root node. parentNode =
				 * (VisTreeNode) visTreeModel.getRoot(); } else { parentNode =
				 * (VisTreeNode) (parentPath.getLastPathComponent()); } return
				 * parentNode; }
				 * 
				 * public VisTreeNode addObject(VisTreeNode child) { VisTreeNode
				 * parentNode = getSelectedNode();
				 * 
				 * return addObject(parentNode, child, true); }
				 */

				public VisTreeNode addObject(VisTreeNode parent,
						VisTreeNode child, boolean shouldBeVisible) {

					visTreeModel.insertNodeInto(child, parent, parent
							.getChildCount());

					// Make sure the user can see the lovely new node.
					if (shouldBeVisible) {
						jTree
								.scrollPathToVisible(new TreePath(child
										.getPath()));
					}
					return child;
				}
			});
		}
		return jButton9;
	}

	/**
	 * This method initializes jPanel27
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel27() {
		if (jPanel27 == null) {
			jPanel27 = new JPanel();
			jPanel27.setLayout(new BorderLayout());
			jPanel27.add(getTextfieldSelectionTS2(), BorderLayout.SOUTH);
			jPanel27.add(getJTextField5(), BorderLayout.NORTH);
		}
		return jPanel27;
	}

	/**
	 * This method initializes jTextField5
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField5() {
		if (textfieldSelectionFilter == null) {
			textfieldSelectionFilter = new ToolTipTextField();
		}
		return textfieldSelectionFilter;
	}

	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.getViewport().add(getJTree1());
			jScrollPane.setPreferredSize(new Dimension(
					this.getMinimumSize().width - 250, 150));
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jPanel28
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel28() {
		if (jPanel28 == null) {
			GridLayout gridLayout2 = new GridLayout(1, 0);
			gridLayout2.setRows(1);
			jPanel28 = new JPanel();
			jPanel28.setLayout(gridLayout2);
			jPanel28.add(getJPanel72(), null);
			jPanel28.add(getJPanel721(), null);
		}
		return jPanel28;
	}

	/**
	 * This method initializes jPanel721
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel721() {
		if (jPanel721 == null) {
			jLabel221 = new JLabel();
			jLabel221.setText("-");
			jPanel721 = new JPanel();
			jPanel721.setLayout(new BorderLayout());
			jPanel721.add(jLabel221, java.awt.BorderLayout.WEST);
			jPanel721.add(getJTextField221(), java.awt.BorderLayout.CENTER);
		}
		return jPanel721;
	}

	/**
	 * This method initializes jTextField221
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField221() {
		if (jTextField221 == null) {
			jTextField221 = new ToolTipTextField();
			jTextField221.setEnabled(false);
			jTextField221.setText(" yyyy/MM/dd.hh:mm:ss");
		}
		return jTextField221;
	}

	/**
	 * This method initializes jScrollPane1
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setBorder(BorderFactory.createTitledBorder(null,
					"Workspace", TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, null, null));
			jScrollPane1.setViewportView(getJList1());
			jScrollPane1.setPreferredSize(new Dimension(
					this.getPreferredSize().width - 220, 50));
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jScrollPane2
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new JScrollPane();
			jScrollPane2
					.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
			jScrollPane2
					.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane2.setViewportView(getJTable());
			jScrollPane2.setPreferredSize(new Dimension(
					this.getMinimumSize().width - 250, 50));
		}
		return jScrollPane2;
	}

	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private JTable getJTable() {
		if (jTable == null) {
			scheduleTableModel = new TaskTableModel(Task.getInfoHeader());
			jTable = new JTable(scheduleTableModel) {
				public boolean isCellEditable(int row, int column) {
					return false;
				}

				// Implement table cell tool tips.
				public String getToolTipText(MouseEvent e) {
					String tip = null;
					Point p = e.getPoint();
					int rowIndex = rowAtPoint(p);
					int colIndex = columnAtPoint(p);
					int realColumnIndex = convertColumnIndexToModel(colIndex);

					tip = (String) this.getValueAt(rowIndex, realColumnIndex);
					return tip;
				}
			};
			jTable.setShowVerticalLines(false);
			jTable.setShowHorizontalLines(false);
			// jTable.addMouseListener();
			// jTable.addTableModelListener(this);
		}
		stm.addTaskListener(scheduleTableModel);
		rtm.addTaskListener(scheduleTableModel);
		return jTable;
	}

	/**
	 * This method initializes jPanel121
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel121() {
		if (jPanel121 == null) {
			jPanel121 = new JPanel();
			jPanel121.setLayout(new BorderLayout());
			jPanel121.setBorder(BorderFactory.createTitledBorder(null,
					"Scatter Plot", TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, null, null));
			jPanel121.add(getJPanel251(), java.awt.BorderLayout.WEST);
			jPanel121.add(getJPanel101(), java.awt.BorderLayout.CENTER);
		}
		return jPanel121;
	}

	/**
	 * This method initializes jPanel251
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel251() {
		if (jPanel251 == null) {
			jPanel251 = new JPanel();
			jPanel251.setLayout(new BorderLayout());
			jPanel251.add(getJRadioButton2(), BorderLayout.CENTER);
		}
		return jPanel251;
	}

	/**
	 * This method initializes jPanel101
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel101() {
		if (jPanel101 == null) {
			jPanel101 = new JPanel();
			jPanel101.setLayout(new GridLayout(1, 0));
			jPanel101.add(getJPanel274(), null);
			jPanel101.add(getJPanel2711(), null);
			jPanel101.add(getJPanel2731(), null);
			jPanel101.add(getJPanel27311(), null);
		}
		return jPanel101;
	}

	/**
	 * This method initializes jPanel274
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel274() {
		if (jPanel274 == null) {
			jLabel44 = new JLabel();
			jLabel44.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel44.setText("x");
			jPanel274 = new JPanel();
			jPanel274.setLayout(new BorderLayout());
			jPanel274.add(jLabel44, BorderLayout.CENTER);
			jPanel274.add(getJComboBox(), BorderLayout.SOUTH);
		}
		return jPanel274;
	}

	/**
	 * This method initializes jPanel2711
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2711() {
		if (jPanel2711 == null) {
			jLabel411 = new JLabel();
			jLabel411.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel411.setText("y");
			jPanel2711 = new JPanel();
			jPanel2711.setLayout(new BorderLayout());
			jPanel2711.add(jLabel411, java.awt.BorderLayout.CENTER);
			jPanel2711.add(getJComboBox2(), BorderLayout.SOUTH);
		}
		return jPanel2711;
	}

	/**
	 * This method initializes jPanel2731
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2731() {
		if (jPanel2731 == null) {
			jLabel4 = new JLabel();
			jLabel4.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4.setBackground(Color.black);
			jLabel4.setText("");
			jLabel4.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel4.setOpaque(true);
			jLabel431 = new JLabel();
			jLabel431.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel431.setText("BG color  ");
			jPanel2731 = new JPanel();
			jPanel2731.setLayout(new BorderLayout());
			jPanel2731.add(jLabel431, java.awt.BorderLayout.WEST);
			jPanel2731.add(jLabel4, BorderLayout.CENTER);
			jPanel2731.add(getJComboBox3(), java.awt.BorderLayout.SOUTH);
		}
		return jPanel2731;
	}

	private int plotType;

	private JPanel jPanel122 = null;

	private JPanel jPanel102 = null;

	private JPanel jPanel275 = null;

	private JLabel jLabel45 = null;

	private JTextField textfieldSelectionTS1 = null;

	private JPanel jPanel2712 = null;

	private JLabel jLabel412 = null;

	private JTextField textfieldSelectionTE1 = null;

	private JPanel jPanel2722 = null;

	private JLabel jLabel422 = null;

	private JTextField textfieldSelectionTD1 = null;

	private JPanel jPanel2738 = null;

	private JLabel jLabel438 = null;

	private JTextField textfieldSelectionPR1 = null;

	private JPanel jPanel27321 = null;

	private JLabel jLabel4321 = null;

	private JTextField textfieldSelectionSA1 = null;

	private JPanel jPanel27331 = null;

	private JLabel jLabel4331 = null;

	private JTextField textfieldSelectionSP1 = null;

	private JPanel jPanel27341 = null;

	private JLabel jLabel4341 = null;

	private JTextField textfieldSelectionDA1 = null;

	private JPanel jPanel27351 = null;

	private JLabel jLabel4351 = null;

	private JTextField textfieldSelectionDP1 = null;

	private JPanel jPanel262 = null;

	private JButton jButton91 = null;

	private JTextField textfieldSelectionIndex = null;

	private JPanel jPanel1021 = null;

	private JPanel jPanel2751 = null;

	private JLabel jLabel451 = null;

	private JTextField textfieldSelectionTS11 = null;

	private JPanel jPanel27121 = null;

	private JLabel jLabel4121 = null;

	private JTextField textfieldSelectionTE11 = null;

	private JPanel jPanel27221 = null;

	private JLabel jLabel4221 = null;

	private JTextField textfieldSelectionTD11 = null;

	private JPanel jPanel27381 = null;

	private JLabel jLabel4381 = null;

	private JTextField textfieldSelectionPR11 = null;

	private JPanel jPanel273211 = null;

	private JLabel jLabel43211 = null;

	private JTextField textfieldSelectionSA11 = null;

	private JPanel jPanel273311 = null;

	private JLabel jLabel43311 = null;

	private JTextField textfieldSelectionSP11 = null;

	private JPanel jPanel273411 = null;

	private JLabel jLabel43411 = null;

	private JTextField textfieldSelectionDA11 = null;

	private JPanel jPanel273511 = null;

	private JLabel jLabel43511 = null;

	private JTextField textfieldSelectionDP11 = null;

	private JPanel jPanel18 = null;

	private JComboBox comboboxScatterPlotX = null;

	private JComboBox comboboxScatterPlotY = null;

	private JComboBox comboboxScatterPlotBgColor = null;

	private JLabel jLabel4 = null;

	private JPanel jPanel29 = null;

	private JPanel jPanel30 = null;

	private JButton jButton1 = null;

	private JButton jButton8 = null;

	private JButton jButton10 = null;

	private JButton jButton11 = null;

	private JButton jButton12 = null;

	private JComboBox comboboxDefaultColor = null;

	private JLabel jLabel6 = null;

	/**
	 * This method initializes jRadioButton2
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButton2() {
		if (radiobuttonScatterPlot == null) {
			radiobuttonScatterPlot = new JRadioButton();
			plotTypeButtons.put(String.valueOf(VisPlotNode.ScatterPlot),
					radiobuttonScatterPlot);
			radiobuttonScatterPlot.setSelected(true);
			setPlotType(VisPlotNode.ScatterPlot);
			radiobuttonScatterPlot
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							setPlotType(VisPlotNode.ScatterPlot);
						}
					});
		}
		return radiobuttonScatterPlot;
	}

	/**
	 * This method initializes jScrollPane3
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane3() {
		if (jScrollPane3 == null) {
			jScrollPane3 = new JScrollPane();
			// jScrollPane3.setBorder(BorderFactory.createTitledBorder(null,
			// "Visualization Tree", TitledBorder.DEFAULT_JUSTIFICATION,
			// TitledBorder.DEFAULT_POSITION, null, null));
			jScrollPane3.getViewport().add(getJTree());
			jScrollPane3.setPreferredSize(new Dimension(
					this.getMinimumSize().width - 250, 50));
		}
		return jScrollPane3;
	}

	/**
	 * This method initializes jPanel273711
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel273711() {
		if (jPanel273711 == null) {
			jLabel43711 = new JLabel();
			jLabel43711.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel43711.setHorizontalTextPosition(SwingConstants.LEFT);
			jLabel43711.setHorizontalAlignment(SwingConstants.LEFT);
			jLabel43711.setText("FILTER");
			jPanel273711 = new JPanel();
			jPanel273711.setLayout(new BorderLayout());
			jPanel273711.add(getJPanel11(), BorderLayout.NORTH);
			jPanel273711.add(getJPanel111(), BorderLayout.SOUTH);
		}
		return jPanel273711;
	}

	/**
	 * This method initializes jRadioButton3
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButton3() {
		if (radiobuttonFilter == null) {
			radiobuttonFilter = new JRadioButton();
			radiobuttonFilter.setSelected(true);
			radiobuttonFilter
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							setSelectionType(radiobuttonFilter.isSelected());
						}
					});
		}
		return radiobuttonFilter;
	}

	void setSelectionType(boolean isFilter) {
		isFilterSelection = isFilter;
		radiobuttonFilter.setSelected(isFilter);
		radiobuttonIndex.setSelected(!isFilter);
		textfieldSelectionFilter.setEnabled(isFilter);
		textfieldSelectionIndex.setEnabled(!isFilter);
	}

	/**
	 * This method initializes jPanel11
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel11() {
		if (jPanel11 == null) {
			jPanel11 = new JPanel();
			jPanel11.setLayout(new BorderLayout());
			jPanel11.add(getJRadioButton3(), BorderLayout.WEST);
			jPanel11.add(jLabel43711, BorderLayout.CENTER);
		}
		return jPanel11;
	}

	/**
	 * This method initializes jPanel111
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel111() {
		if (jPanel111 == null) {
			jLabel437111 = new JLabel();
			jLabel437111.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel437111.setHorizontalTextPosition(SwingConstants.LEFT);
			jLabel437111.setHorizontalAlignment(SwingConstants.LEFT);
			jLabel437111.setText("INDEX");
			jPanel111 = new JPanel();
			jPanel111.setLayout(new BorderLayout());
			jPanel111.add(getJRadioButton31(), BorderLayout.WEST);
			jPanel111.add(jLabel437111, BorderLayout.CENTER);
		}
		return jPanel111;
	}

	/**
	 * This method initializes jRadioButton31
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getJRadioButton31() {
		if (radiobuttonIndex == null) {
			radiobuttonIndex = new JRadioButton();
			radiobuttonIndex
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							setSelectionType(!radiobuttonIndex.isSelected());
						}
					});
		}
		return radiobuttonIndex;
	}

	/**
	 * This method initializes jPanel122
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel122() {
		if (jPanel122 == null) {
			jPanel122 = new JPanel();
			jPanel122.setLayout(new BorderLayout());
			jPanel122.setBorder(BorderFactory.createTitledBorder(null, "Color",
					TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, new Font("Dialog",
							Font.BOLD, 12), new Color(51, 51, 51)));
			jPanel122.add(getJPanel18(), BorderLayout.CENTER);
			jPanel122.add(getJPanel262(), java.awt.BorderLayout.EAST);
			jPanel122.add(getJPanel37(), BorderLayout.SOUTH);
		}
		return jPanel122;
	}

	/**
	 * This method initializes jPanel102
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel102() {
		if (jPanel102 == null) {
			jPanel102 = new JPanel();
			jPanel102.setLayout(new GridLayout(1, 0));
			jPanel102.add(getJPanel275(), null);
			jPanel102.add(getJPanel27351(), null);
			jPanel102.add(getJPanel2712(), null);
			jPanel102.add(getJPanel2722(), null);
			jPanel102.add(getJPanel2738(), null);
			jPanel102.add(getJPanel27321(), null);
			jPanel102.add(getJPanel27331(), null);
			jPanel102.add(getJPanel27341(), null);
		}
		return jPanel102;
	}

	/**
	 * This method initializes jPanel275
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel275() {
		if (jPanel275 == null) {
			jLabel45 = new JLabel();
			jLabel45.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel45.setBackground(Color.white);
			jLabel45.setOpaque(true);
			jLabel45.setPreferredSize(new Dimension(0, 10));
			jLabel45.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jPanel275 = new JPanel();
			jPanel275.setLayout(new BorderLayout());
			jPanel275.add(jLabel45, java.awt.BorderLayout.CENTER);
			jPanel275.add(getToolTipTextfieldSelectionTS1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel275;
	}

	/**
	 * This method initializes textfieldSelectionTS1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getToolTipTextfieldSelectionTS1() {
		if (textfieldSelectionTS1 == null) {
			textfieldSelectionTS1 = new ToolTipTextField();
			fgColorTextFields.put("0", textfieldSelectionTS1);
		}
		return textfieldSelectionTS1;
	}

	/**
	 * This method initializes jPanel2712
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2712() {
		if (jPanel2712 == null) {
			jLabel412 = new JLabel();
			jLabel412.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel412.setOpaque(true);
			jLabel412.setBackground(Color.red);
			jLabel412.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jPanel2712 = new JPanel();
			jPanel2712.setLayout(new BorderLayout());
			jPanel2712.add(jLabel412, java.awt.BorderLayout.CENTER);
			jPanel2712.add(getTextfieldSelectionTE1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel2712;
	}

	/**
	 * This method initializes textfieldSelectionTE1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionTE1() {
		if (textfieldSelectionTE1 == null) {
			textfieldSelectionTE1 = new ToolTipTextField();
			fgColorTextFields.put("2", textfieldSelectionTE1);
		}
		return textfieldSelectionTE1;
	}

	/**
	 * This method initializes jPanel2722
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2722() {
		if (jPanel2722 == null) {
			jLabel422 = new JLabel();
			jLabel422.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel422.setOpaque(true);
			jLabel422.setBackground(new Color(0, 205, 0));
			jLabel422.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jPanel2722 = new JPanel();
			jPanel2722.setLayout(new BorderLayout());
			jPanel2722.add(jLabel422, java.awt.BorderLayout.CENTER);
			jPanel2722.add(getTextfieldSelectionTD1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel2722;
	}

	/**
	 * This method initializes textfieldSelectionTD1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionTD1() {
		if (textfieldSelectionTD1 == null) {
			textfieldSelectionTD1 = new ToolTipTextField();
			fgColorTextFields.put("3", textfieldSelectionTD1);
		}
		return textfieldSelectionTD1;
	}

	/**
	 * This method initializes jPanel2738
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2738() {
		if (jPanel2738 == null) {
			jLabel438 = new JLabel();
			jLabel438.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel438.setOpaque(true);
			jLabel438.setBackground(Color.blue);
			jLabel438.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jPanel2738 = new JPanel();
			jPanel2738.setLayout(new BorderLayout());
			jPanel2738.add(jLabel438, java.awt.BorderLayout.CENTER);
			jPanel2738.add(getTextfieldSelectionPR1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel2738;
	}

	/**
	 * This method initializes textfieldSelectionPR1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionPR1() {
		if (textfieldSelectionPR1 == null) {
			textfieldSelectionPR1 = new ToolTipTextField();
			fgColorTextFields.put("4", textfieldSelectionPR1);
		}
		return textfieldSelectionPR1;
	}

	/**
	 * This method initializes jPanel27321
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel27321() {
		if (jPanel27321 == null) {
			jLabel4321 = new JLabel();
			jLabel4321.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4321.setOpaque(true);
			jLabel4321.setBackground(Color.cyan);
			jLabel4321.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jPanel27321 = new JPanel();
			jPanel27321.setLayout(new BorderLayout());
			jPanel27321.add(jLabel4321, java.awt.BorderLayout.CENTER);
			jPanel27321.add(getTextfieldSelectionSA1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel27321;
	}

	/**
	 * This method initializes textfieldSelectionSA1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionSA1() {
		if (textfieldSelectionSA1 == null) {
			textfieldSelectionSA1 = new ToolTipTextField();
			fgColorTextFields.put("5", textfieldSelectionSA1);
		}
		return textfieldSelectionSA1;
	}

	/**
	 * This method initializes jPanel27331
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel27331() {
		if (jPanel27331 == null) {
			jLabel4331 = new JLabel();
			jLabel4331.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4331.setOpaque(true);
			jLabel4331.setBackground(Color.magenta);
			jLabel4331.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jPanel27331 = new JPanel();
			jPanel27331.setLayout(new BorderLayout());
			jPanel27331.add(jLabel4331, java.awt.BorderLayout.CENTER);
			jPanel27331.add(getTextfieldSelectionSP1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel27331;
	}

	/**
	 * This method initializes textfieldSelectionSP1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionSP1() {
		if (textfieldSelectionSP1 == null) {
			textfieldSelectionSP1 = new ToolTipTextField();
			fgColorTextFields.put("6", textfieldSelectionSP1);
		}
		return textfieldSelectionSP1;
	}

	/**
	 * This method initializes jPanel27341
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel27341() {
		if (jPanel27341 == null) {
			jLabel4341 = new JLabel();
			jLabel4341.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4341.setOpaque(true);
			jLabel4341.setBackground(Color.yellow);
			jLabel4341.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jPanel27341 = new JPanel();
			jPanel27341.setLayout(new BorderLayout());
			jPanel27341.add(jLabel4341, java.awt.BorderLayout.CENTER);
			jPanel27341.add(getTextfieldSelectionDA1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel27341;
	}

	/**
	 * This method initializes textfieldSelectionDA1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionDA1() {
		if (textfieldSelectionDA1 == null) {
			textfieldSelectionDA1 = new ToolTipTextField();
			fgColorTextFields.put("7", textfieldSelectionDA1);
		}
		return textfieldSelectionDA1;
	}

	/**
	 * This method initializes jPanel27351
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel27351() {
		if (jPanel27351 == null) {
			jLabel4351 = new JLabel();
			jLabel4351.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4351.setOpaque(true);
			jLabel4351.setBackground(Color.black);
			jLabel4351.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jPanel27351 = new JPanel();
			jPanel27351.setLayout(new BorderLayout());
			jPanel27351.add(jLabel4351, java.awt.BorderLayout.CENTER);
			jPanel27351.add(getTextfieldSelectionDP1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel27351;
	}

	/**
	 * This method initializes textfieldSelectionDP1
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionDP1() {
		if (textfieldSelectionDP1 == null) {
			textfieldSelectionDP1 = new ToolTipTextField();
			fgColorTextFields.put("1", textfieldSelectionDP1);
		}
		return textfieldSelectionDP1;
	}

	/**
	 * This method initializes jPanel262
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel262() {
		if (jPanel262 == null) {
			jLabel6 = new JLabel();
			jLabel6.setText("Default");
			jPanel262 = new JPanel();
			jPanel262.setLayout(new BorderLayout());
			jPanel262.add(getJButton91(), BorderLayout.SOUTH);
			jPanel262.add(getJComboBox4(), BorderLayout.CENTER);
			jPanel262.add(jLabel6, BorderLayout.WEST);
		}
		return jPanel262;
	}

	/**
	 * This method initializes jButton91
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton91() {
		if (jButton91 == null) {
			jButton91 = new JButton();
			jButton91.setText("Brush");
			jButton91.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String name = textfieldSelectionData.getText();
					VisDataNode data = visTreeModel.getDataNode(name);
					Hashtable<String, String> color = getBrushColor();
					if (data != null) {
						rm.brush(data, color);
						data.setColor(color);
						data.setDescription();
					}
				}
			});
		}
		return jButton91;
	}

	Hashtable<String, String> getBrushColor() {
		Hashtable<String, String> col = new Hashtable<String, String>();

		int def = Integer.parseInt((String) comboboxDefaultColor
				.getSelectedItem());

		col.put("DEFAULT", String.valueOf(def));

		for (int i = 0; i < 24; i++) {
			if (i == 8)
				i = 16;
			String filter;
			// StringBuffer sb;
			// String REGEX = "[a-z]{1,4}";
			// Pattern p = Pattern.compile(REGEX);
			// Matcher m;
			if (def != i
					&& !(filter = ((JTextField) fgColorTextFields.get(String
							.valueOf(i))).getText()).equals("")) {
				// sb=new StringBuffer(filter);
				// m=p.matcher(filter);
				// while (m.find()){
				// sb.insert(m.start(), "iset(iset.cur())$");
				// }
				col.put(i < 10 ? "0" + i : String.valueOf(i), filter);
			}
		}
		return col;
	}

	void setBrushColor(Hashtable<String, String> color) {
		if (color == null)
			return;
		comboboxDefaultColor.setSelectedIndex(Integer.parseInt(color
				.get("DEFAULT")));
		updateColorUI((String) comboboxDefaultColor.getSelectedItem());

		for (int i = 0; i < 24; i++) {
			if (i == 8)
				i = 16;
			String filter;
			// StringBuffer sb;
			// String REGEX = "[a-z]{1,4}";
			// Pattern p = Pattern.compile(REGEX);
			// Matcher m;
			if ((filter = (String) color.get(String.valueOf(i < 10 ? "0" + i
					: String.valueOf(i)))) == null)
				((JTextField) fgColorTextFields.get(String.valueOf(i)))
						.setText("");
			else
				((JTextField) fgColorTextFields.get(String.valueOf(i)))
						.setText(filter);
		}
	}

	/**
	 * This method initializes textfieldSelectionTS2
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionTS2() {
		if (textfieldSelectionIndex == null) {
			textfieldSelectionIndex = new ToolTipTextField();
			textfieldSelectionIndex.setEnabled(false);
			textfieldSelectionIndex.setEditable(false);
		}
		return textfieldSelectionIndex;
	}

	/**
	 * This method initializes jPanel1021
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1021() {
		if (jPanel1021 == null) {
			jPanel1021 = new JPanel();
			jPanel1021.setLayout(new GridLayout(1, 0));
			jPanel1021.add(getJPanel2751(), null);
			jPanel1021.add(getJPanel27121(), null);
			jPanel1021.add(getJPanel27221(), null);
			jPanel1021.add(getJPanel27381(), null);
			jPanel1021.add(getJPanel273211(), null);
			jPanel1021.add(getJPanel273311(), null);
			jPanel1021.add(getJPanel273411(), null);
			jPanel1021.add(getJPanel273511(), null);
		}
		return jPanel1021;
	}

	/**
	 * This method initializes jPanel2751
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2751() {
		if (jPanel2751 == null) {
			jLabel451 = new JLabel();
			jLabel451.setBackground(new Color(239, 118, 119));
			jLabel451.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel451.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel451.setPreferredSize(new Dimension(0, 10));
			jLabel451.setOpaque(true);
			jPanel2751 = new JPanel();
			jPanel2751.setLayout(new BorderLayout());
			jPanel2751.add(jLabel451, java.awt.BorderLayout.CENTER);
			jPanel2751.add(getTextfieldSelectionTS11(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel2751;
	}

	/**
	 * This method initializes textfieldSelectionTS11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionTS11() {
		if (textfieldSelectionTS11 == null) {
			textfieldSelectionTS11 = new ToolTipTextField();
			fgColorTextFields.put("16", textfieldSelectionTS11);
		}
		return textfieldSelectionTS11;
	}

	/**
	 * This method initializes jPanel27121
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel27121() {
		if (jPanel27121 == null) {
			jLabel4121 = new JLabel();
			jLabel4121.setBackground(new Color(135, 178, 212));
			jLabel4121.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4121.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel4121.setOpaque(true);
			jPanel27121 = new JPanel();
			jPanel27121.setLayout(new BorderLayout());
			jPanel27121.add(jLabel4121, java.awt.BorderLayout.CENTER);
			jPanel27121.add(getTextfieldSelectionTE11(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel27121;
	}

	/**
	 * This method initializes textfieldSelectionTE11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionTE11() {
		if (textfieldSelectionTE11 == null) {
			textfieldSelectionTE11 = new ToolTipTextField();
			fgColorTextFields.put("17", textfieldSelectionTE11);
		}
		return textfieldSelectionTE11;
	}

	/**
	 * This method initializes jPanel27221
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel27221() {
		if (jPanel27221 == null) {
			jLabel4221 = new JLabel();
			jLabel4221.setBackground(new Color(255, 178, 202));
			jLabel4221.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4221.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel4221.setOpaque(true);
			jPanel27221 = new JPanel();
			jPanel27221.setLayout(new BorderLayout());
			jPanel27221.add(jLabel4221, java.awt.BorderLayout.CENTER);
			jPanel27221.add(getTextfieldSelectionTD11(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel27221;
	}

	/**
	 * This method initializes textfieldSelectionTD11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionTD11() {
		if (textfieldSelectionTD11 == null) {
			textfieldSelectionTD11 = new ToolTipTextField();
			fgColorTextFields.put("18", textfieldSelectionTD11);
		}
		return textfieldSelectionTD11;
	}

	/**
	 * This method initializes jPanel27381
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel27381() {
		if (jPanel27381 == null) {
			jLabel4381 = new JLabel();
			jLabel4381.setBackground(new Color(193, 149, 200));
			jLabel4381.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4381.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel4381.setOpaque(true);
			jPanel27381 = new JPanel();
			jPanel27381.setLayout(new BorderLayout());
			jPanel27381.add(jLabel4381, java.awt.BorderLayout.CENTER);
			jPanel27381.add(getTextfieldSelectionPR11(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel27381;
	}

	/**
	 * This method initializes textfieldSelectionPR11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionPR11() {
		if (textfieldSelectionPR11 == null) {
			textfieldSelectionPR11 = new ToolTipTextField();
			fgColorTextFields.put("19", textfieldSelectionPR11);
		}
		return textfieldSelectionPR11;
	}

	/**
	 * This method initializes jPanel273211
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel273211() {
		if (jPanel273211 == null) {
			jLabel43211 = new JLabel();
			jLabel43211.setBackground(new Color(148, 207, 146));
			jLabel43211.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel43211.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel43211.setOpaque(true);
			jPanel273211 = new JPanel();
			jPanel273211.setLayout(new BorderLayout());
			jPanel273211.add(jLabel43211, java.awt.BorderLayout.CENTER);
			jPanel273211.add(getTextfieldSelectionSA11(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel273211;
	}

	/**
	 * This method initializes textfieldSelectionSA11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionSA11() {
		if (textfieldSelectionSA11 == null) {
			textfieldSelectionSA11 = new ToolTipTextField();
			fgColorTextFields.put("20", textfieldSelectionSA11);
		}
		return textfieldSelectionSA11;
	}

	/**
	 * This method initializes jPanel273311
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel273311() {
		if (jPanel273311 == null) {
			jLabel43311 = new JLabel();
			jLabel43311.setBackground(new Color(255, 255, 133));
			jLabel43311.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel43311.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel43311.setOpaque(true);
			jPanel273311 = new JPanel();
			jPanel273311.setLayout(new BorderLayout());
			jPanel273311.add(jLabel43311, java.awt.BorderLayout.CENTER);
			jPanel273311.add(getTextfieldSelectionSP11(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel273311;
	}

	/**
	 * This method initializes textfieldSelectionSP11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionSP11() {
		if (textfieldSelectionSP11 == null) {
			textfieldSelectionSP11 = new ToolTipTextField();
			fgColorTextFields.put("21", textfieldSelectionSP11);
		}
		return textfieldSelectionSP11;
	}

	/**
	 * This method initializes jPanel273411
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel273411() {
		if (jPanel273411 == null) {
			jLabel43411 = new JLabel();
			jLabel43411.setBackground(new Color(202, 154, 126));
			jLabel43411.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel43411.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel43411.setOpaque(true);
			jPanel273411 = new JPanel();
			jPanel273411.setLayout(new BorderLayout());
			jPanel273411.add(jLabel43411, java.awt.BorderLayout.CENTER);
			jPanel273411.add(getTextfieldSelectionDA11(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel273411;
	}

	/**
	 * This method initializes textfieldSelectionDA11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionDA11() {
		if (textfieldSelectionDA11 == null) {
			textfieldSelectionDA11 = new ToolTipTextField();
			fgColorTextFields.put("22", textfieldSelectionDA11);
		}
		return textfieldSelectionDA11;
	}

	/**
	 * This method initializes jPanel273511
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel273511() {
		if (jPanel273511 == null) {
			jLabel43511 = new JLabel();
			jLabel43511.setBackground(new Color(250, 179, 217));
			jLabel43511.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel43511.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel43511.setOpaque(true);
			jPanel273511 = new JPanel();
			jPanel273511.setLayout(new BorderLayout());
			jPanel273511.add(jLabel43511, java.awt.BorderLayout.CENTER);
			jPanel273511.add(getTextfieldSelectionDP11(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel273511;
	}

	/**
	 * This method initializes textfieldSelectionDP11
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getTextfieldSelectionDP11() {
		if (textfieldSelectionDP11 == null) {
			textfieldSelectionDP11 = new ToolTipTextField();
			fgColorTextFields.put("23", textfieldSelectionDP11);
		}
		return textfieldSelectionDP11;
	}

	/**
	 * This method initializes jPanel18
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel18() {
		if (jPanel18 == null) {
			jPanel18 = new JPanel();
			jPanel18.setLayout(new BoxLayout(getJPanel18(), BoxLayout.Y_AXIS));
			jPanel18.add(getJPanel102(), null);
			jPanel18.add(getJPanel1021(), null);
		}
		return jPanel18;
	}

	/**
	 * This method initializes jComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBox() {
		if (comboboxScatterPlotX == null) {
			comboboxScatterPlotX = new JComboBox(attributes);
			comboboxScatterPlotX.setSelectedIndex(0);
		}
		return comboboxScatterPlotX;
	}

	/**
	 * This method initializes jComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBox2() {
		if (comboboxScatterPlotY == null) {
			comboboxScatterPlotY = new JComboBox(attributes);
			comboboxScatterPlotY.setSelectedIndex(8);
		}
		return comboboxScatterPlotY;
	}

	/**
	 * This method initializes jComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBox3() {
		if (comboboxScatterPlotBgColor == null) {
			comboboxScatterPlotBgColor = new JComboBox(bgColors);
			comboboxScatterPlotBgColor.setSelectedIndex(3);
			jLabel4.setBackground(getColor((String) comboboxScatterPlotBgColor
					.getSelectedItem()));
			comboboxScatterPlotBgColor
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (comboboxScatterPlotBgColor.getSelectedIndex() != -1)
								jLabel4
										.setBackground(getColor((String) comboboxScatterPlotBgColor
												.getSelectedItem()));
						}
					});

		}
		return comboboxScatterPlotBgColor;
	}

	Color getColor(String colorName) {
		try {
			// Find the field and value of colorName
			Field field = Class.forName("java.awt.Color").getField(colorName);
			return (Color) field.get(null);
		} catch (Exception e) {
			return null;
		}
	}

	/**
	 * This method initializes jPanel29
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel29() {
		if (jPanel29 == null) {
			jPanel29 = new JPanel();
			jPanel29.setLayout(new BorderLayout());
			jPanel29.setBorder(BorderFactory.createTitledBorder(null,
					"Visualization Tree", TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, null, null));
			jPanel29.add(getJPanel30(), BorderLayout.WEST);
			jPanel29.add(getJScrollPane3(), BorderLayout.CENTER);
		}
		return jPanel29;
	}

	/**
	 * This method initializes jPanel30
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel30() {
		if (jPanel30 == null) {
			jPanel30 = new JPanel();
			GridLayout gridLayout = new GridLayout(0, 1);
			jPanel30.setLayout(gridLayout);
			jPanel30.add(getJButton1(), null);
			jPanel30.add(getJButton13(), null);
			jPanel30.add(getJButton10(), null);
			jPanel30.add(getJButton11(), null);
			jPanel30.add(getJButton12(), null);
			jPanel30.add(getJButton8(), null);
		}
		return jPanel30;
	}

	/**
	 * This method initializes jButton1
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText("Toggle Plot(s)");
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					VisTreeNode node = visTreeModel
							.getNode(textfieldSelectionData.getText());
					if (node == null)
						return;

					if (node instanceof VisPlotNode) {
						rm.togglePlot((VisPlotNode) node);
					} else {
						rm.togglePlots((VisDataNode) node);
					}
				}
			});
		}
		return jButton1;
	}

	/**
	 * This method initializes jButton8
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton8() {
		if (jButton8 == null) {
			jButton8 = new JButton();
			jButton8.setText("Delete");
			jButton8.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					VisTreeNode node = visTreeModel
							.getNode(textfieldSelectionData.getText());
					if (node == null)
						return;

					if (node instanceof VisPlotNode)
						rm.deletePlot((VisPlotNode) node);
					else
						rm.deletePlot((VisDataNode) node);

					visTreeModel.removeNodeFromParent(node);
				}
			});
		}
		return jButton8;
	}

	/**
	 * This method initializes jButton10
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton10() {
		if (jButton10 == null) {
			jButton10 = new JButton();
			jButton10.setText("View Data");
		}
		return jButton10;
	}

	/**
	 * This method initializes jButton11
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton11() {
		if (jButton11 == null) {
			jButton11 = new JButton();
			jButton11.setText("Save Plot(s)");
			jButton11.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					VisTreeNode node = visTreeModel
							.getNode(textfieldSelectionData.getText());
					if (node == null)
						return;

					String dir = jTextField21.getText();
					if (new File(dir).isDirectory()
							&& dir.charAt(dir.length() - 1) != '/')
						dir += '/';
					if (node instanceof VisPlotNode) {
						rm.savePlot((VisPlotNode) node, dir);
					} else {
						rm.savePlot((VisDataNode) node, dir);
					}
				}
			});
		}
		return jButton11;
	}

	/**
	 * This method initializes jButton12
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton12() {
		if (jButton12 == null) {
			jButton12 = new JButton();
			jButton12.setText("Save All Plots");
			jButton12.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					VisTreeNode node = visTreeModel
							.getNode(textfieldSelectionData.getText());
					if (textfieldSelectionData.getText().equals("VisRoot"))
						node = visTreeModel.getRoot();

					if (node == null)
						return;

					String dir = jTextField21.getText();
					if (new File(dir).isDirectory()
							&& dir.charAt(dir.length() - 1) != '/')
						dir += '/';
					if (node instanceof VisDataNode || node.getLevel() == 0)
						rm.saveAllPlot(node, dir);
					// rm.saveAllPlot(visTreeModel.getRoot(), dir);

				}
			});
		}
		return jButton12;
	}

	/**
	 * This method initializes jComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBox4() {
		if (comboboxDefaultColor == null) {
			comboboxDefaultColor = new JComboBox(brushColors);
			comboboxDefaultColor.setSelectedItem("3");
			updateColorUI("3");
			comboboxDefaultColor
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							int sel;
							if ((sel = comboboxDefaultColor.getSelectedIndex()) != -1) {
								updateColorUI((String) comboboxDefaultColor
										.getSelectedItem());
							}
						}
					});
		}
		return comboboxDefaultColor;
	}

	Hashtable<String, JTextField> fgColorTextFields; // @jve:decl-index=0:

	private JButton jButton13 = null;

	private JPanel jPanel31 = null;

	private JButton jButton14 = null;

	private JButton jButton15 = null;

	private JButton jButton16 = null;

	private JButton jButton17 = null;

	private JScrollPane jScrollPane4 = null;

	private JCheckBox jCheckBox = null;

	void updateColorUI(String sel) {
		int intSel = Integer.parseInt(sel);
		JTextField tf;
		Color selColor = Color.LIGHT_GRAY;
		Color otherColor = new Color(238, 238, 238);
		for (int i = 0; i < 24; i++) {
			if (i == 8)
				i = 16;
			if (intSel == i) {
				tf = (JTextField) fgColorTextFields.get(sel);
				tf.setEnabled(false);
				tf.setBackground(selColor);
			} else {
				tf = (JTextField) fgColorTextFields.get(String.valueOf(i));
				tf.setEnabled(true);
				tf.setBackground(otherColor);
			}
		}
	}

	/**
	 * This method initializes jButton13
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton13() {
		if (jButton13 == null) {
			jButton13 = new JButton();
			jButton13.setText("Tile Plots");
			jButton13.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					VisTreeNode node = visTreeModel
							.getNode(textfieldSelectionData.getText());
					if (node == null || node instanceof VisPlotNode)
						return;

					Point ori = getLocationOnScreen();
					ori.x += getSize().width;
					Dimension screen = Toolkit.getDefaultToolkit()
							.getScreenSize();
					Dimension size = new Dimension(screen.width - ori.x,
							screen.height - ori.y);
					rm.tilePlots((VisDataNode) node, ori, size);
				}
			});
		}
		return jButton13;
	}

	/**
	 * This method initializes jPanel31
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel31() {
		if (jPanel31 == null) {
			jPanel31 = new JPanel();
			GridLayout gridLayout = new GridLayout(0, 1);
			jPanel31.setLayout(gridLayout);
			jPanel31.add(getJButton14(), null);
			jPanel31.add(getJButton17(), null);
			jPanel31.add(getJButton15(), null);
			jPanel31.add(getJButton16(), null);
		}
		return jPanel31;
	}

	/**
	 * This method initializes jButton14
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton14() {
		if (jButton14 == null) {
			jButton14 = new JButton();
			jButton14.setText("Cancel");
			jButton14.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int[] selected = jTable.getSelectedRows();
					if (selected.length == 0)
						return;

					for (int i : selected) {
						Task t = scheduleTableModel.getTask(i);
						if (t instanceof ShellTask || t.type == Task.PRELOAD)
							stm.cancellTask(t);
						else
							rtm.cancellTask(t);
					}
				}
			});
		}
		return jButton14;
	}

	/**
	 * This method initializes jButton15
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton15() {
		if (jButton15 == null) {
			jButton15 = new JButton();
			jButton15.setText("Clean");
			jButton15.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int[] selected = jTable.getSelectedRows();
					if (selected.length == 0)
						return;

					for (int i : selected) {
						Task t = scheduleTableModel.getTask(i);
						if (t.status == Task.FAILED
								|| t.status == Task.CANCELLED) {
							if (t instanceof ShellTask
									|| t.type == Task.PRELOAD)
								stm.removeTask(t);
							else
								rtm.removeTask(t);
						}
					}
				}
			});
		}
		return jButton15;
	}

	/**
	 * This method initializes jButton16
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton16() {
		if (jButton16 == null) {
			jButton16 = new JButton();
			jButton16.setText("Clean All");
			jButton16.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int[] selected = jTable.getSelectedRows();
					if (selected.length == 0)
						return;

					for (int i : selected) {
						Task t = scheduleTableModel.getTask(i);
						if (t.status == Task.COMPLETED
								|| t.status == Task.FAILED
								|| t.status == Task.CANCELLED) {
							if (t instanceof ShellTask
									|| t.type == Task.PRELOAD)
								stm.removeTask(t);
							else
								rtm.removeTask(t);
						}
					}
				}
			});
		}
		return jButton16;
	}

	/**
	 * This method initializes jButton17
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton17() {
		if (jButton17 == null) {
			jButton17 = new JButton();
			jButton17.setText("Restart");
			jButton17.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int[] selected = jTable.getSelectedRows();
					if (selected.length == 0)
						return;

					for (int i : selected) {
						Task t = scheduleTableModel.getTask(i);
						if (t.status == Task.FAILED
								|| t.status == Task.CANCELLED) {
							if (t instanceof ShellTask
									|| t.type == Task.PRELOAD)
								stm.restartTask(t);
							else
								rtm.restartTask(t);
						}
					}
				}
			});
		}
		return jButton17;
	}

	/**
	 * This method initializes jScrollPane4
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane4() {
		if (jScrollPane4 == null) {
			jScrollPane4 = new JScrollPane();
			jScrollPane4.setViewportView(getJPanel());
		}
		return jScrollPane4;
	}

	/**
	 * This method initializes jCheckBox
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setSelected(true);
			jCheckBox.setText("save only");
			isSaveOnly = jCheckBox.isSelected();
			jCheckBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					isSaveOnly = jCheckBox.isSelected();
				}
			});
		}
		return jCheckBox;
	}

	boolean isSaveOnly;

	private JPanel jPanel32 = null;

	private JPanel jPanel33 = null;

	private JPanel jPanel331 = null;

	private JButton jButton41 = null;

	private JLabel jLabel51 = null;

	private JPanel jPanel34 = null;

	private JPanel jPanel341 = null;

	private JRadioButton jRadioButton11 = null;

	private JTextField jTextField4 = null;

	/**
	 * This method initializes jPanel32
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel32() {
		if (jPanel32 == null) {
			jPanel32 = new JPanel();
			jPanel32.setLayout(new BoxLayout(getJPanel32(), BoxLayout.X_AXIS));
			jPanel32.add(getJPanel33(), null);
			jPanel32.add(getJPanel331(), null);
		}
		return jPanel32;
	}

	/**
	 * This method initializes jPanel33
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel33() {
		if (jPanel33 == null) {
			jLabel5 = new JLabel();
			jLabel5.setText("->.csv");
			jLabel5.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jPanel33 = new JPanel();
			jPanel33.setLayout(new BorderLayout());
			jPanel33.add(jLabel5, BorderLayout.WEST);
			jPanel33.add(getJButton4(), BorderLayout.CENTER);
		}
		return jPanel33;
	}

	/**
	 * This method initializes jPanel331
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel331() {
		if (jPanel331 == null) {
			jLabel51 = new JLabel();
			jLabel51.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel51.setText("-> .ws ");
			jPanel331 = new JPanel();
			jPanel331.setLayout(new BorderLayout());
			jPanel331.add(jLabel51, BorderLayout.WEST);
			jPanel331.add(getJButton41(), BorderLayout.CENTER);
		}
		return jPanel331;
	}

	/**
	 * This method initializes jButton41
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton41() {
		if (jButton41 == null) {
			jButton41 = new JButton();
			jButton41.setText("Preload");
			jButton41.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// System.out.println("Preload started.");

					String outpath = jTextField21.getText();
					if (new File(outpath).isDirectory())
						return;

					String[] preload = sm.getRPreloadCmd(outpath);
					ShellTask st = new ShellTask(stm, Task.PRELOAD, sm,
							preload, null);
					stm.addTask(st);
				}
			});
		}
		return jButton41;
	}

	/**
	 * This method initializes jPanel34
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel34() {
		if (jPanel34 == null) {
			jPanel34 = new JPanel();
			jPanel34.setLayout(new BorderLayout());
			jPanel34.add(getJCheckBox(), BorderLayout.WEST);
			jPanel34.add(getJButton9(), BorderLayout.CENTER);
		}
		return jPanel34;
	}

	/**
	 * This method initializes jPanel341
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel341() {
		if (jPanel341 == null) {
			jPanel341 = new JPanel();
			jPanel341.setLayout(new BorderLayout());
			jPanel341.add(getJRadioButton11(), BorderLayout.WEST);
			jPanel341.add(getJTextField42(), BorderLayout.CENTER);
		}
		return jPanel341;
	}

	/**
	 * This method initializes jCheckBox1
	 * 
	 * @return javax.swing.JCheckBox
	 */
	private JRadioButton getJRadioButton11() {
		if (jRadioButton11 == null) {
			jRadioButton11 = new JRadioButton();
			plotTypeButtons.put("-1", jRadioButton11);
			jRadioButton11.setSelected(false);
			jRadioButton11.setText("as plots in :");
			jRadioButton11
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							setPlotType(-1);
						}
					});
		}
		return jRadioButton11;
	}

	private JPanel jPanel27311 = null;

	private JLabel jLabel4311 = null;

	private JLabel jLabel41 = null;

	private JComboBox comboboxParallelCoordinatePlotFgColor = null;

	private JPanel jPanel2511 = null;

	private JRadioButton radiobuttonScatterPlot1 = null;

	private JPanel jPanel273111 = null;

	private JLabel jLabel43111 = null;

	private JLabel jLabel413 = null;

	private JComboBox comboboxScatterPlotFgColor = null;

	private JPanel jPanel35 = null;

	private JTextField jTextField5 = null;

	private JLabel jLabel7 = null;

	private JPanel jPanel36 = null;

	private Hashtable<String, JRadioButton> plotTypeButtons; // @jve:decl-index=0:

	private JPanel jPanel1211 = null;

	private JPanel jPanel2512 = null;

	private JRadioButton radiobuttonScatterPlot2 = null;

	private JPanel jPanel1011 = null;

	private JPanel jPanel2741 = null;

	private JLabel jLabel441 = null;

	private JComboBox comboboxScatterPlotX1 = null;

	private JPanel jPanel273112 = null;

	private JLabel jLabel43112 = null;

	private JLabel jLabel414 = null;

	private JComboBox comboboxHistogramFgColor = null;

	private JPanel jPanel12111 = null;

	private JPanel jPanel25121 = null;

	private JRadioButton radiobuttonScatterPlot21 = null;

	private JPanel jPanel10111 = null;

	private JPanel jPanel27411 = null;

	private JLabel jLabel4411 = null;

	private JComboBox comboboxScatterPlotX11 = null;

	private JPanel jPanel2731121 = null;

	private JLabel jLabel431121 = null;

	private JLabel jLabel4141 = null;

	private JComboBox comboboxBarchartFgColor = null;

	private JPanel jPanel37 = null;

	private JLabel jLabel8 = null;

	private JComboBox jComboBox = null;

	private JButton jButton18 = null;

	private JPanel jPanel38 = null;

	private JPanel jPanel39 = null;

	private JRadioButton radiobuttonScatterPlot11 = null;

	private JPanel jPanel351 = null;

	private JTextField jTextField51 = null;

	private JPanel jPanel132 = null;

	private JPanel jPanel25112 = null;

	private JRadioButton radiobuttonScatterPlot111 = null;

	private JPanel jPanel352 = null;

	private JPanel jPanel362 = null;

	private JTextField jTextField511 = null;

	private JLabel jLabel71 = null;

	private JPanel jPanel2731111 = null;

	private JLabel jLabel431111 = null;

	private JLabel jLabel4131 = null;

	private JComboBox comboboxParallelCoordinatePlotFgColor1 = null;

	private void setPlotType(int type) {
		plotType = type;
		Iterator i = plotTypeButtons.keySet().iterator();
		while (i.hasNext()) {
			String key = (String) i.next();
			JRadioButton rb = plotTypeButtons.get(key);
			if (key.equals(String.valueOf(plotType)))
				rb.setSelected(true);
			else
				rb.setSelected(false);
		}
	}

	/**
	 * This method initializes jTextField4
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField42() {
		if (jTextField4 == null) {
			jTextField4 = new ToolTipTextField();
		}
		return jTextField4;
	}

	/**
	 * This method initializes jPanel27311
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel27311() {
		if (jPanel27311 == null) {
			jLabel41 = new JLabel();
			jLabel41.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel41.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel41.setText("");
			jLabel41.setBackground(Color.green);
			jLabel41.setOpaque(true);
			jLabel4311 = new JLabel();
			jLabel4311.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4311.setText("FG color");
			jPanel27311 = new JPanel();
			jPanel27311.setLayout(new BorderLayout());
			jPanel27311.add(jLabel4311, java.awt.BorderLayout.WEST);
			jPanel27311.add(jLabel41, java.awt.BorderLayout.CENTER);
			jPanel27311.add(getJComboBox31(), java.awt.BorderLayout.SOUTH);
		}
		return jPanel27311;
	}

	/**
	 * This method initializes comboboxScatterPlotBgColor1
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBox31() {
		if (comboboxScatterPlotFgColor == null) {
			comboboxScatterPlotFgColor = new JComboBox(fgColors);
			comboboxScatterPlotFgColor.setSelectedIndex(5);
			jLabel41.setBackground(getColor((String) comboboxScatterPlotFgColor
					.getSelectedItem()));
			comboboxScatterPlotFgColor
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (comboboxScatterPlotFgColor.getSelectedIndex() != -1)
								jLabel41
										.setBackground(getColor((String) comboboxScatterPlotFgColor
												.getSelectedItem()));
						}
					});

		}
		return comboboxScatterPlotFgColor;
	}

	/**
	 * This method initializes jPanel2511
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2511() {
		if (jPanel2511 == null) {
			jPanel2511 = new JPanel();
			jPanel2511.setLayout(new BorderLayout());
			jPanel2511.add(getRadiobuttonScatterPlot1(),
					java.awt.BorderLayout.CENTER);
		}
		return jPanel2511;
	}

	/**
	 * This method initializes radiobuttonScatterPlot1
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getRadiobuttonScatterPlot1() {
		if (radiobuttonScatterPlot1 == null) {
			radiobuttonScatterPlot1 = new JRadioButton();
			plotTypeButtons.put(String
					.valueOf(VisPlotNode.ParallelCoordinatePlot),
					radiobuttonScatterPlot1);
			radiobuttonScatterPlot1.setSelected(false);
			radiobuttonScatterPlot1
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							setPlotType(VisPlotNode.ParallelCoordinatePlot);
						}
					});
		}
		return radiobuttonScatterPlot1;
	}

	/**
	 * This method initializes jPanel273111
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel273111() {
		if (jPanel273111 == null) {
			jLabel413 = new JLabel();
			jLabel413.setBackground(Color.black);
			jLabel413.setOpaque(true);
			jLabel413.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel413.setText("");
			jLabel413.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel43111 = new JLabel();
			jLabel43111.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel43111.setText("FG color");
			jPanel273111 = new JPanel();
			jPanel273111.setLayout(new BorderLayout());
			jPanel273111.add(jLabel43111, java.awt.BorderLayout.WEST);
			jPanel273111.add(jLabel413, java.awt.BorderLayout.CENTER);
			jPanel273111.add(getComboboxParallelCoordinatePlotFgColor(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel273111;
	}

	/**
	 * This method initializes comboboxScatterPlotFgColor1
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getComboboxParallelCoordinatePlotFgColor() {
		if (comboboxParallelCoordinatePlotFgColor == null) {
			comboboxParallelCoordinatePlotFgColor = new JComboBox(fgColors);
			comboboxParallelCoordinatePlotFgColor.setSelectedIndex(0);
			jLabel413
					.setBackground(getColor((String) comboboxParallelCoordinatePlotFgColor
							.getSelectedItem()));
			comboboxParallelCoordinatePlotFgColor
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (comboboxParallelCoordinatePlotFgColor
									.getSelectedIndex() != -1)
								jLabel413
										.setBackground(getColor((String) comboboxParallelCoordinatePlotFgColor
												.getSelectedItem()));
						}
					});

		}
		return comboboxParallelCoordinatePlotFgColor;
	}

	/**
	 * This method initializes jPanel35
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel35() {
		if (jPanel35 == null) {
			jLabel7 = new JLabel();
			jLabel7.setText("x1, x2, ... , xN");
			jPanel35 = new JPanel();
			jPanel35.setLayout(new GridLayout(1, 0));
			jPanel35.add(getJPanel36(), null);
			jPanel35.add(getJPanel273111(), new GridBagConstraints());
		}
		return jPanel35;
	}

	/**
	 * This method initializes jTextField5
	 * 
	 * @return javax.swing.JTextField
	 */
	private JTextField getJTextField52() {
		if (jTextField5 == null) {
			jTextField5 = new JTextField();
		}
		return jTextField5;
	}

	/**
	 * This method initializes jPanel36
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel36() {
		if (jPanel36 == null) {
			jPanel36 = new JPanel();
			jPanel36.setLayout(new BorderLayout());
			jPanel36.add(getJTextField52(), BorderLayout.CENTER);
			jPanel36.add(jLabel7, BorderLayout.NORTH);
		}
		return jPanel36;
	}

	/**
	 * This method initializes jPanel1211
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1211() {
		if (jPanel1211 == null) {
			jPanel1211 = new JPanel();
			jPanel1211.setLayout(new BorderLayout());
			jPanel1211.setBorder(BorderFactory.createTitledBorder(null,
					"Histogram", TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, null, null));
			jPanel1211.add(getJPanel2512(), java.awt.BorderLayout.WEST);
			jPanel1211.add(getJPanel1011(), java.awt.BorderLayout.CENTER);
		}
		return jPanel1211;
	}

	/**
	 * This method initializes jPanel2512
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2512() {
		if (jPanel2512 == null) {
			jPanel2512 = new JPanel();
			jPanel2512.setLayout(new BorderLayout());
			jPanel2512.add(getRadiobuttonScatterPlot2(),
					java.awt.BorderLayout.CENTER);
		}
		return jPanel2512;
	}

	/**
	 * This method initializes radiobuttonScatterPlot2
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getRadiobuttonScatterPlot2() {
		if (radiobuttonScatterPlot2 == null) {
			radiobuttonScatterPlot2 = new JRadioButton();
			plotTypeButtons.put(String.valueOf(VisPlotNode.Histogram),
					radiobuttonScatterPlot2);
			radiobuttonScatterPlot2.setSelected(false);
			radiobuttonScatterPlot2
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							setPlotType(VisPlotNode.Histogram);
						}
					});
		}
		return radiobuttonScatterPlot2;
	}

	/**
	 * This method initializes jPanel1011
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1011() {
		if (jPanel1011 == null) {
			jPanel1011 = new JPanel();
			jPanel1011.setLayout(new GridLayout(1, 0));
			jPanel1011.add(getJPanel2741(), null);
			jPanel1011.add(getJPanel273112(), null);
		}
		return jPanel1011;
	}

	/**
	 * This method initializes jPanel2741
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2741() {
		if (jPanel2741 == null) {
			jLabel441 = new JLabel();
			jLabel441.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel441.setText("x");
			jPanel2741 = new JPanel();
			jPanel2741.setLayout(new BorderLayout());
			jPanel2741.add(jLabel441, java.awt.BorderLayout.CENTER);
			jPanel2741.add(getComboboxScatterPlotX1(), BorderLayout.SOUTH);
		}
		return jPanel2741;
	}

	/**
	 * This method initializes comboboxScatterPlotX1
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getComboboxScatterPlotX1() {
		if (comboboxScatterPlotX1 == null) {
			comboboxScatterPlotX1 = new JComboBox(attributes);
		}
		return comboboxScatterPlotX1;
	}

	/**
	 * This method initializes jPanel273112
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel273112() {
		if (jPanel273112 == null) {
			jLabel414 = new JLabel();
			jLabel414.setBackground(Color.black);
			jLabel414.setOpaque(true);
			jLabel414.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel414.setText("");
			jLabel414.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel43112 = new JLabel();
			jLabel43112.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel43112.setText("FG color");
			jPanel273112 = new JPanel();
			jPanel273112.setLayout(new BorderLayout());
			jPanel273112.add(jLabel43112, java.awt.BorderLayout.WEST);
			jPanel273112.add(jLabel414, java.awt.BorderLayout.CENTER);
			jPanel273112.add(getComboboxScatterPlotFgColor1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel273112;
	}

	/**
	 * This method initializes comboboxScatterPlotFgColor1
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getComboboxScatterPlotFgColor1() {
		if (comboboxHistogramFgColor == null) {
			comboboxHistogramFgColor = new JComboBox(fgColors);
			comboboxHistogramFgColor.setSelectedIndex(0);
			jLabel414.setBackground(getColor((String) comboboxHistogramFgColor
					.getSelectedItem()));
			comboboxHistogramFgColor
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (comboboxHistogramFgColor.getSelectedIndex() != -1)
								jLabel414
										.setBackground(getColor((String) comboboxHistogramFgColor
												.getSelectedItem()));
						}
					});
		}
		return comboboxHistogramFgColor;
	}

	/**
	 * This method initializes jPanel12111
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel12111() {
		if (jPanel12111 == null) {
			jPanel12111 = new JPanel();
			jPanel12111.setLayout(new BorderLayout());
			jPanel12111.setBorder(BorderFactory.createTitledBorder(null,
					"Barchart", TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, null, null));
			jPanel12111.add(getJPanel25121(), java.awt.BorderLayout.WEST);
			jPanel12111.add(getJPanel10111(), java.awt.BorderLayout.CENTER);
		}
		return jPanel12111;
	}

	/**
	 * This method initializes jPanel25121
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel25121() {
		if (jPanel25121 == null) {
			jPanel25121 = new JPanel();
			jPanel25121.setLayout(new BorderLayout());
			jPanel25121.add(getRadiobuttonScatterPlot21(),
					java.awt.BorderLayout.CENTER);
		}
		return jPanel25121;
	}

	/**
	 * This method initializes radiobuttonScatterPlot21
	 * 
	 * @return javax.swing.JRadioButton
	 */
	private JRadioButton getRadiobuttonScatterPlot21() {
		if (radiobuttonScatterPlot21 == null) {
			radiobuttonScatterPlot21 = new JRadioButton();
			plotTypeButtons.put(String.valueOf(VisPlotNode.BarChart),
					radiobuttonScatterPlot21);
			radiobuttonScatterPlot21.setSelected(false);
			radiobuttonScatterPlot21
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							setPlotType(VisPlotNode.BarChart);
						}
					});
		}
		return radiobuttonScatterPlot21;
	}

	/**
	 * This method initializes jPanel10111
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel10111() {
		if (jPanel10111 == null) {
			jPanel10111 = new JPanel();
			jPanel10111.setLayout(new GridLayout(1, 0));
			jPanel10111.add(getJPanel27411(), null);
			jPanel10111.add(getJPanel2731121(), null);
		}
		return jPanel10111;
	}

	/**
	 * This method initializes jPanel27411
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel27411() {
		if (jPanel27411 == null) {
			jLabel4411 = new JLabel();
			jLabel4411.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4411.setText("x");
			jPanel27411 = new JPanel();
			jPanel27411.setLayout(new BorderLayout());
			jPanel27411.add(jLabel4411, java.awt.BorderLayout.CENTER);
			jPanel27411.add(getComboboxScatterPlotX11(), BorderLayout.SOUTH);
		}
		return jPanel27411;
	}

	/**
	 * This method initializes comboboxScatterPlotX11
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getComboboxScatterPlotX11() {
		if (comboboxScatterPlotX11 == null) {
			comboboxScatterPlotX11 = new JComboBox(attributes);
		}
		return comboboxScatterPlotX11;
	}

	/**
	 * This method initializes jPanel2731121
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2731121() {
		if (jPanel2731121 == null) {
			jLabel4141 = new JLabel();
			jLabel4141.setBackground(Color.black);
			jLabel4141.setOpaque(true);
			jLabel4141.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4141.setText("");
			jLabel4141.setBorder(BorderFactory
					.createBevelBorder(BevelBorder.LOWERED));
			jLabel431121 = new JLabel();
			jLabel431121.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel431121.setText("FG color");
			jPanel2731121 = new JPanel();
			jPanel2731121.setLayout(new BorderLayout());
			jPanel2731121.add(jLabel431121, java.awt.BorderLayout.WEST);
			jPanel2731121.add(jLabel4141, java.awt.BorderLayout.CENTER);
			jPanel2731121.add(getComboboxHistogramFgColor1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel2731121;
	}

	/**
	 * This method initializes comboboxHistogramFgColor1
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getComboboxHistogramFgColor1() {
		if (comboboxBarchartFgColor == null) {
			comboboxBarchartFgColor = new JComboBox(fgColors);
			comboboxBarchartFgColor.setSelectedIndex(0);
			jLabel4141.setBackground(getColor((String) comboboxBarchartFgColor
					.getSelectedItem()));
			comboboxBarchartFgColor
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (comboboxBarchartFgColor.getSelectedIndex() != -1)
								jLabel414
										.setBackground(getColor((String) comboboxBarchartFgColor
												.getSelectedItem()));
						}
					});
		}
		return comboboxBarchartFgColor;
	}

	/**
	 * This method initializes jPanel37
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel37() {
		if (jPanel37 == null) {
			ImageIcon icon = new ImageIcon("resource/rainbow.png");
			jLabel8 = new JImageLabel(icon);
			jLabel8.setText("");
			jPanel37 = new JPanel();
			jPanel37.setLayout(new BorderLayout());
			jPanel37.add(jLabel8, BorderLayout.CENTER);
			jPanel37.add(getJPanel38(), BorderLayout.EAST);
		}
		return jPanel37;
	}

	/**
	 * This method initializes jComboBox
	 * 
	 * @return javax.swing.JComboBox
	 */
	private JComboBox getJComboBox5() {
		if (jComboBox == null) {
			jComboBox = new JComboBox(attributes);
			jComboBox.setSelectedIndex(0);
		}
		return jComboBox;
	}

	/**
	 * This method initializes jButton18
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getJButton18() {
		if (jButton18 == null) {
			jButton18 = new JButton();
			jButton18.setText("Rainbow Brush");
			jButton18.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					String name = textfieldSelectionData.getText();
					VisDataNode data = visTreeModel.getDataNode(name);
					String attribute = (String) jComboBox.getSelectedItem();
					if (data != null && attribute != null) {
						rm.brush(data, attribute);
						data.colorfilter = "Rainbow: " + attribute + "\n";
						data.setDescription();
					}
				}
			});
		}
		return jButton18;
	}

	/**
	 * This method initializes jPanel38
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel38() {
		if (jPanel38 == null) {
			jPanel38 = new JPanel();
			jPanel38.setLayout(new BorderLayout());
			jPanel38.add(getJButton18(), BorderLayout.EAST);
			jPanel38.add(getJComboBox5(), BorderLayout.CENTER);
		}
		return jPanel38;
	}

	/**
	 * This method initializes jPanel39	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel39() {
		if (jPanel39 == null) {
			jPanel39 = new JPanel();
			jPanel39.setLayout(new GridLayout(1,0));
			jPanel39.add(getJPanel1211(), new GridBagConstraints());
			jPanel39.add(getJPanel12111(), new GridBagConstraints());
		}
		return jPanel39;
	}

	/**
	 * This method initializes jPanel132	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel132() {
		if (jPanel132 == null) {
			jPanel132 = new JPanel();
			jPanel132.setLayout(new BorderLayout());
			jPanel132.setBorder(BorderFactory.createTitledBorder(null,
					"Mosaic Plot",
					TitledBorder.DEFAULT_JUSTIFICATION,
					TitledBorder.DEFAULT_POSITION, null, null));
			jPanel132.add(getJPanel25112(), BorderLayout.WEST);
			jPanel132.add(getJPanel352(), BorderLayout.CENTER);
		}
		return jPanel132;
	}

	/**
	 * This method initializes jPanel25112	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel25112() {
		if (jPanel25112 == null) {
			jPanel25112 = new JPanel();
			jPanel25112.setLayout(new BorderLayout());
			jPanel25112.add(getRadiobuttonScatterPlot111(), java.awt.BorderLayout.CENTER);
		}
		return jPanel25112;
	}

	/**
	 * This method initializes radiobuttonScatterPlot111	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getRadiobuttonScatterPlot111() {
		if (radiobuttonScatterPlot111 == null) {
			radiobuttonScatterPlot111 = new JRadioButton();
			plotTypeButtons.put(String
					.valueOf(VisPlotNode.MosaicPlot),
					radiobuttonScatterPlot111);
			radiobuttonScatterPlot111.setSelected(false);
			radiobuttonScatterPlot111
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							setPlotType(VisPlotNode.MosaicPlot);
						}
					});
		}
		return radiobuttonScatterPlot111;
	}

	/**
	 * This method initializes jPanel352	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel352() {
		if (jPanel352 == null) {
			jLabel71 = new JLabel();
			jLabel71.setText("x1, y1, x2, y2, ... , xN, yN");
			jPanel352 = new JPanel();
			jPanel352.setLayout(new GridLayout(1, 0));
			jPanel352.add(getJPanel362(), null);
			jPanel352.add(getJPanel2731111(), new GridBagConstraints());
		}
		return jPanel352;
	}

	/**
	 * This method initializes jPanel362	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel362() {
		if (jPanel362 == null) {
			jPanel362 = new JPanel();
			jPanel362.setLayout(new BorderLayout());
			jPanel362.add(getJTextField511(), java.awt.BorderLayout.CENTER);
			jPanel362.add(jLabel71, java.awt.BorderLayout.NORTH);
		}
		return jPanel362;
	}

	/**
	 * This method initializes jTextField511	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField511() {
		if (jTextField511 == null) {
			jTextField511 = new JTextField();
		}
		return jTextField511;
	}

	/**
	 * This method initializes jPanel2731111	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel2731111() {
		if (jPanel2731111 == null) {
			jLabel4131 = new JLabel();
			jLabel4131.setBackground(Color.black);
			jLabel4131.setOpaque(true);
			jLabel4131.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel4131.setText("");
			jLabel4131.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
			jLabel431111 = new JLabel();
			jLabel431111.setDisplayedMnemonic(KeyEvent.VK_UNDEFINED);
			jLabel431111.setText("FG color");
			jPanel2731111 = new JPanel();
			jPanel2731111.setLayout(new BorderLayout());
			jPanel2731111.add(jLabel431111, java.awt.BorderLayout.WEST);
			jPanel2731111.add(jLabel4131, java.awt.BorderLayout.CENTER);
			jPanel2731111.add(getComboboxParallelCoordinatePlotFgColor1(),
					java.awt.BorderLayout.SOUTH);
		}
		return jPanel2731111;
	}

	/**
	 * This method initializes comboboxParallelCoordinatePlotFgColor1	
	 * 	
	 * @return javax.swing.JComboBox	
	 */    
	private JComboBox getComboboxParallelCoordinatePlotFgColor1() {
		if (comboboxParallelCoordinatePlotFgColor1 == null) {
			comboboxParallelCoordinatePlotFgColor1 = new JComboBox(fgColors);
			comboboxParallelCoordinatePlotFgColor1.setSelectedIndex(0);
			jLabel4131
					.setBackground(getColor((String) comboboxParallelCoordinatePlotFgColor1
							.getSelectedItem()));
			comboboxParallelCoordinatePlotFgColor1
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							if (comboboxParallelCoordinatePlotFgColor1
									.getSelectedIndex() != -1)
								jLabel4131
										.setBackground(getColor((String) comboboxParallelCoordinatePlotFgColor1
												.getSelectedItem()));
						}
					});
		}
		return comboboxParallelCoordinatePlotFgColor1;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// just making sure we have the right version of everything
		if (!Rengine.versionCheck()) {
			System.err
					.println("** Version mismatch - Java files don't match library version.");
			System.exit(1);
		}

		// start up Rengine
		System.out.println("Creating Rengine (with arguments)");
		// 1) we pass the arguments from the command line
		// 2) we won't use the main loop at first, we'll start it later
		// (that's the "false" as second argument)
		// 3) the callbacks are implemented by the TextConsole class above
		RManager rm = new RManager(new Rengine(args, false, null));
		// Rengine re = new Rengine(args, false, rm);
		rm.re.addMainLoopCallbacks(rm);

		System.out.println("Rengine created, waiting for R");
		// the engine creates R is a new thread, so we should wait until it's
		// ready
		if (!rm.re.waitForR()) {
			System.out.println("Cannot load R");
			return;
		}

		// System.out.println("re-routing stdout/err into R console");
		// System.setOut(new PrintStream(new RConsoleOutputStream(re, 0)));
		// System.setErr(new PrintStream(new RConsoleOutputStream(re, 1)));

		// System.out.println("Letting go; use main loop from now on");

		// load necessary libraries by loading JGR
		try {
			rm.re.eval("library(JGR)", false);
		} catch (Exception e) {
			System.out.println("EX:" + e);
			e.printStackTrace();
		}

		ShellManager sm = new ShellManager();
		TaskManager shellTaskManager = new TaskManager();
		TaskManager rTaskManager = new TaskManager();

		UniVis uv = new UniVis(rm, sm, shellTaskManager, rTaskManager);
		uv.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		uv.setVisible(true);
		// SwingUtilities.invokeLater(new Runnable() {
		// public void run() {
		// univis thisClass = new univis(re);
		// thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		// thisClass.setVisible(true);
		// }
		// });
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.stm.start();
		this.rtm.start();
		this.pathChooser = new JFileChooser();
		this.fileTreeModel = new FileTreeModel(new File(this.getJTextField3()
				.getText()));
		this.visTreeModel = new VisTreeModel();
		this.fgColorTextFields = new Hashtable<String, JTextField>();
		this.plotTypeButtons = new Hashtable<String, JRadioButton>();
		this.workspace = new Hashtable<String, String>();

		this.setTitle("UniVis");
		Dimension size = new Dimension(520, Toolkit.getDefaultToolkit()
				.getScreenSize().height - 50);
		// Dimension size = new Dimension(520, 718);
		this.setMinimumSize(size);
		this.setPreferredSize(this.getMinimumSize());
		this.setContentPane(getJContentPane());

		// this.pack();
		// this.setExtendedState(Frame.MAXIMIZED_VERT);
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJScrollPane4(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

} // @jve:decl-index=0:visual-constraint="31,53"
