package univis;

import java.util.Vector;

import javax.swing.DefaultListModel;
import javax.swing.SwingUtilities;

import util.Task;
import util.TaskListener;
import r.RTask;

public class WorkspaceListModel extends DefaultListModel implements
		TaskListener {
	String[] list;

	public void taskUpdated(Task t, Vector<Task> tasks) {
		if (t.type == Task.LOAD) {
			list = (((RTask) t).rm.getDataList()).clone();
			if (list == null)
				return;

			Runnable updater = new Runnable() {
				public void run() {
					update(list.clone());
				}
			};
			if (SwingUtilities.isEventDispatchThread())
				updater.run();
			else
				SwingUtilities.invokeLater(updater);
		}
	}

	public void update(String[] list) {
		removeAllElements();
		for (String s : list) {
			if (s == null)
				continue;
			addElement(s);
		}
	}
}
