package util;

import java.util.Vector;

public abstract class Task extends Thread {
	public static final int DUMP = 0;

	public static final int PRELOAD = 1;

	public static final int LOAD = 2;

	public static final int PREPROCESS = 3;

	public static final int VISUALIZE = 4;

	public static final int GETTIMEWINDOW = 5;

	public static final int GETFLOWNUMBER = 6;
	
	public static final int MISC = 7;

	public static final String[] TYPENAME = { "DUMP", "PRELOAD", "LOAD",
			"PREPROCESS", "VISUALIZE", "GETTIMEWINDOW", "GETFLOWNUMBER", "MISC" };

	public static final int QUEUED = 0;

	public static final int INPROGRESS = 1;

	public static final int COMPLETED = 2;

	public static final int FAILED = 3;

	public static final int CANCELLED = 4;

	public static final String[] STATUSNAME = { "QUEUED", "INPROGRESS",
			"COMPLETED", "FAILED", "CANCELED" };

	public int type;

	public String description;

	public String[] args;

	public String startTime = "N/A";

	public String endTime = "N/A";

	public String duration = "N/A";

	public int status;

	public TaskManager tm;

	public Task(TaskManager tm, int type, String[] args) {
		this.tm = tm;
		this.type = type;
		this.args = args;
		args2Description();
	}

	private void args2Description() {
		if (args == null)
			description = "";
		else {
			StringBuffer sb = new StringBuffer();
			for (String s : args)
				sb.append(s + " ");
			description = sb.toString();
		}
	}

	static public Vector getInfoHeader() {
		Vector<String> hdr = new Vector<String>();
		hdr.addElement("Status");
		hdr.addElement("Type");
		hdr.addElement("Start");
		hdr.addElement("End");
		hdr.addElement("Duration");
		hdr.addElement("Description");
		return hdr;
	}

	public Vector getInfo() {
		Vector<String> info = new Vector<String>();
		info.addElement(STATUSNAME[status]);
		info.addElement(TYPENAME[type]);
		info.addElement(startTime);
		info.addElement(endTime);
		info.addElement(duration);
		info.addElement(description);
		return info;
	}

	public void run() {
	}
}
