package util;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JTextField;

public class ToolTipTextField extends JTextField {
	public ToolTipTextField() {
		super();
		this.addKeyListener(new java.awt.event.KeyAdapter() {
			public void keyTyped(java.awt.event.KeyEvent e) {
				JTextField s = (JTextField) e.getSource();
				if (e.getKeyChar() >= 32 && e.getKeyChar() <= 126) // printable 7bit ASCII
					s.setToolTipText(s.getText() + e.getKeyChar());
				else
					s.setToolTipText(s.getText());
			}
		});
		
		this.addMouseListener(new MouseAdapter(){
			public void mouseEntered(MouseEvent e){
				String tip = null;
				ToolTipTextField source = (ToolTipTextField)e.getSource();
				if (source != null && !source.getText().equals(""))
					tip = source.getText();
				source.setToolTipText(tip);
			}
		});
	}
}
