package util;

import java.awt.Image;

import r.VisTask;

public class VisPlotNode extends VisTreeNode {
	public static final int ScatterPlot = 0;
	public static final int ParallelCoordinatePlot = 1;
	public static final int Histogram = 2;
	public static final int BarChart = 3;
	public static final int BoxPlot = 4;
	public static final int MosaicPlot = 5;
	public static final int HammockPlot = 6;
	public static final int MapPlot = 7;
	
	public static final String[] PLOTNAME = { "iplot", "ipcp", "ihist", "ibar", "ibox", "imosaic", "ihammock", "imap"};
	
	public Image thumbnail = null;
	public int id;
	public boolean isVisible = true;
	public int type;
	public String[] attributes;
	public String background;
	public String foreground;
	
	public VisPlotNode(String name, int id, boolean isVisible, int type, String[] attributes, String background, String foreground){
		super(name,false);
		//id = Integer.parseInt((name.substring(name.lastIndexOf('_') + 1, name.length()))) + 1;
		this.id = id;
		this.isVisible = isVisible;
		this.type = type;
		this.attributes = attributes.clone();
		this.background = background;
		this.foreground = foreground;
	}
	
	public VisPlotNode(String name, int id, String description, boolean isVisible){
		super(name, true, description);
		this.id = id;
		this.isVisible = isVisible;
	}
	
	public void setDescription(){		
		this.description = this.name + "_" +PLOTNAME[this.type] + "(" + getAttribute() + ")";
//		this.name = this.description;
		this.setUserObject(this.description);
	}
	
	public String getDescription(){
		return this.description;
	}
	
	public String getAttribute(){
		String attribute = "";
		for (int i = 0; i < attributes.length - 1; i++)
			attribute += attributes[i] + ",";
		attribute += attributes[attributes.length - 1];
		return attribute;
	}
}
