package util;

import java.util.Comparator;

import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;

public class VisTreeModel extends DefaultTreeModel { //implements TreeModel {
	private VisTreeNode root;
	
//	private Vector listeners = new Vector();

	private Comparator comparator;

	public Comparator getComparator() {
		return comparator;
	}

	public void setComparator(Comparator cmp) {
		comparator = cmp;
	}
	
	public VisTreeModel(){
		super(null, true);
		this.root = new VisTreeNode("VisRoot", true, "Bogus root node of the visualization tree.");
	}
	
	public VisDataNode getSameDataNode(String index, VisDataNode parent){
		VisDataNode dn = null;
		
		if (index == null || parent == null)
			return null;
		
		//if (parent.getChildCount() == 0 && )
		
		for (int i = 0; i < parent.getChildCount(); i++){
//			if (!parent.getChildAt(i).isLeaf())
//				System.err.println("compare index of node " + (parent.getChildAt(i)).toString() + " : " + index + "<->" + ((VisDataNode)(parent.getChildAt(i))).originalIndex);
			if ((!parent.getChildAt(i).isLeaf()) &&
					(index.equals((dn = (VisDataNode)parent.getChildAt(i)).originalIndex))){
				return dn;
			}
		}
		
		return null;
	}
	
	public VisTreeNode getNode(String name){
		VisTreeNode n= null;
		for (int i = 0; i < root.getChildCount(); i++){
			if ((n = getNode(name, (VisTreeNode) root.getChildAt(i))) != null)
				return n;
		}
		
		return n;
	}
	
	private VisTreeNode getNode(String name, VisTreeNode p){
		VisTreeNode n = null;
		
		if (p.name.equals(name))
			return p;
		
		for (int i = 0; i < p.getChildCount(); i++){
			if ((n = getNode(name, (VisTreeNode) p.getChildAt(i))) != null)
				return n;
		}
		
		return n;
	}
	
	public VisDataNode getDataNode(String name){
		VisTreeNode n = getNode(name);
		return  (n instanceof VisDataNode) ?  (VisDataNode)n : null;
	}

/*	public void addTreeModelListener(TreeModelListener l) {
		// TODO Auto-generated method stub
		listeners.add(l);
	}*/

	public VisTreeNode getChild(Object parent, int index) {
		// TODO Auto-generated method stub
//		this.sortChildren(parent);
//		VisTreeNode p = (VisTreeNode) parent;
//		return p.getChildAt(index);
		return (VisTreeNode) super.getChild(parent, index);
	}

	public int getLeafChildCount(Object parent){
		TreeNode p = (TreeNode) parent;
		int ret = 0;
		for (int i = 0; i < p.getChildCount(); i++){
			if (p.getChildAt(i).isLeaf())
				ret++;
		}
		return ret;
	}
	
/*	public int getChildCount(Object parent) {
		// TODO Auto-generated method stub
//		this.sortChildren(parent);
		VisTreeNode p = (VisTreeNode) parent;
		return p.getChildCount();
	}*/

/*	public int getIndexOfChild(Object parent, Object child) {
		// TODO Auto-generated method stub
//		this.sortChildren(parent);
		VisTreeNode p = (VisTreeNode) parent;
		VisTreeNode c = (VisTreeNode) child;
		return p.getIndex(c);
	}*/

	public VisTreeNode getRoot() {
		// TODO Auto-generated method stub
		return root;
	}

/*	public boolean isLeaf(Object node) {
		// TODO Auto-generated method stub
		return (node instanceof VisPlotNode)||((node==root)&&(root.getChildCount()==0));
	}*/

/*	public void removeTreeModelListener(TreeModelListener l) {
		// TODO Auto-generated method stub
		listeners.remove(l);
	}*/

/*	public void valueForPathChanged(TreePath path, Object newValue) {
		// TODO Auto-generated method stub

	}*/

/*	private void sortChildren(Object parent) {
		if (parent == null)
			return;

		VisTreeNode node = (VisTreeNode) parent;
		File file = (File) node.getUserObject();
		Vector children = new Vector();
		String[] tmp = file.list();
		for (int i = 0; i < tmp.length; i++)
			children.addElement(tmp[i]);
		Collections.sort(children);
		// Collections.sort(children, String.CASE_INSENSITIVE_ORDER);
		// Collections.sort(children, this.getComparator());
		node.removeAllChildren();
		Iterator childrenIterator = children.iterator();
		while (childrenIterator.hasNext()) {
			node.add(new VisTreeNode(new File(file.getPath()
					+ File.separator + (String) childrenIterator.next())));
		}
	}*/
}
